; $Id: dm_basis_hkl.pro,v 1.3 2003/09/12 19:09:03 qiuym Exp $
; requires vectors (3,3) ar,br,cr of the reciprocal lattice
; returns vectors (3,3)  A,B,C such that if Q=h*ar+k*br+l*cr (with h,k,l in rlu)
; then h=dot(Q,A), k=dot(Q,B), l=dot(Q,C)
function dm_basis_hkl,abc_r
	ABC	=	fltarr(3,3)
;	old algorithm
;		t=crossp(crossp(abc_r[*,0],abc_r[*,1]),crossp(abc_r[*,2],abc_r[*,1]))
;		ABC[*,0]=crossp(abc_r[*,1],crossp(crossp(abc_r[*,2],abc_r[*,1]),t))/norm(t)^2
;		t=crossp(crossp(abc_r[*,1],abc_r[*,0]),crossp(abc_r[*,2],abc_r[*,0]))
;		ABC[*,1]=crossp(abc_r[*,0],crossp(crossp(abc_r[*,2],abc_r[*,0]),t))/norm(t)^2
;		t=crossp(crossp(abc_r[*,2],abc_r[*,0]),crossp(abc_r[*,1],abc_r[*,0]))
;		ABC[*,2]=crossp(abc_r[*,0],crossp(crossp(abc_r[*,1],abc_r[*,0]),t))/norm(t)^2
;	new one
;		A= bxc/(a.(bxc))
;		B= cxa/(a.(bxc))
;		C= axb/(a.(bxc))
	vol		=	transpose(abc_r[*,0]) # crossp(abc_r[*,1],abc_r[*,2])
	ABC[*,0]=	crossp(abc_r[*,1],abc_r[*,2])/vol[0]
	ABC[*,1]=	crossp(abc_r[*,2],abc_r[*,0])/vol[0]
	ABC[*,2]=	crossp(abc_r[*,0],abc_r[*,1])/vol[0]
	return,ABC
end