; $Id: dm_choose_trajdata.pro,v 1.7 2003/10/10 14:14:07 qiuym Exp $
; choose the data according to plot trajectory type
; parameter:
;   id: an integer
; keywords:
;  input:
;   range:
;   leave_empty:
;  output:
;   data:
;   label:
;   index:

pro dcs_mslice::dm_choose_trajdata,id,data=data,label=label,index=index,range=range,leave_empty=leave_empty,error=error,debug=debug
    if keyword_set(debug) then begin
       print,'[[choose traj data...'
       current=systime(/sec)
    endif
    nen    =n_elements((*self.projStrPtr).en)
    n2th=n_elements((*self.projStrPtr).two_theta)
    case self.samp_typ of
     1:begin   ;powder
       case id of
         -1:  begin
          data    =(*self.projStrPtr).qty
          error   =(*self.projStrPtr).err
          label   ='Intensity'
          if strlen(self.intn_lab) ne 0 then label=self.intn_lab
          end
         0:   begin
          data    =(*self.projStrPtr).en#(fltarr(n2th)+1.0)
          label   ='E (meV)'
          end
         1:   begin
          data    =(*self.projStrPtr).Q
          label   ='|Q| ('+string('c5'XB)+'!U-1!N)'
          end
         2:   begin
          data    =(fltarr(nen)+1)#(*self.projStrPtr).two_theta
          label   ='2theta ('+string('b0'XB)+')'
          end
         3:   begin
          data    =(fltarr(nen)+1)#(findgen(n2th)+1.0)
          label   ='Detector Group Number'
          end
         else:begin
          data    =(fltarr(nen)+1.0)#(findgen(n2th)+1.0)
          label   ='None'
          end
       endcase
       end
     0:begin   ;single crystal
       case id of
         -1:  begin
          data    =(*self.projStrPtr).qty
          error   =(*self.projStrPtr).err
          label   ='Intensity'
          if strlen(self.intn_lab) ne 0 then label=self.intn_lab
          end
         0:   begin
          data    =reform((*self.projStrPtr).Q[0,*,*])
          label   ='Q!Dx!N ('+string('c5'XB)+'!U-1!N)'
          end
         1:   begin
          data    =reform((*self.projStrPtr).Q[1,*,*])
          label   ='Q!Dy!N ('+string('c5'XB)+'!U-1!N)'
          end
         2:   begin
          data    =reform((*self.projStrPtr).Q[2,*,*])
          label   ='Q!Dz!N ('+string('c5'XB)+'!U-1!N)'
          end
         3:   begin
          data    =reform((*self.projStrPtr).hkl[0,*,*])
          label   ='H (rlu)'
          end
         4:   begin
          data    =reform((*self.projStrPtr).hkl[1,*,*])
          label   ='K (rlu)'
          end
         5:   begin
          data    =reform((*self.projStrPtr).hkl[2,*,*])
          label   ='L (rlu)'
          end
         6:   begin
          data    =reform((*self.projStrPtr).V[0,*,*])
          label   =self.traj_type[6]
          end
         7:   begin
          data    =reform((*self.projStrPtr).V[1,*,*])
          label   =self.traj_type[7]
          end
         8:   begin
          data    =reform((*self.projStrPtr).V[2,*,*])
          label   =self.traj_type[8]
          end
         9:   begin
          data    =(*self.projStrPtr).en#(fltarr(n2th)+1.0)
          label   ='E (meV)'
          end
         10:  begin
          data    =reform(sqrt(((*self.projStrPtr).Q[0,*,*])^2+((*self.projStrPtr).Q[1,*,*])^2+$
                     ((*self.projStrPtr).Q[2,*,*])^2))
          label   ='|Q| ('+string('c5'XB)+'!U-1!N)'
          end
         11: begin
          data    =(fltarr(nen)+1.0)#(*self.projStrPtr).two_theta
          label   ='2theta ('+string('b0'XB)+')'
          end
         12:  begin
          data    =(fltarr(nen)+1.0)#(findgen(n2th)+1.0)
          label   ='Detector Group Number'
          end
         else:begin
          data    =(fltarr(nen)+1.0)#(findgen(n2th)+1.0)
          label   ='None'
          end
       endcase
       end
     2:begin   ;diffuse scattering
       tmp   =size((*self.projStrPtr).Q)
       if tmp[0] eq 2 then nfile=1L else nfile=tmp[3]
       case id of
         -1:  begin
          data    =(*self.projStrPtr).qty
          error   =(*self.projStrPtr).err
          label   ='Intensity'
          if strlen(self.intn_lab) ne 0 then label=self.intn_lab
          end
         0:   begin
          data    =reform((*self.projStrPtr).Q[0,*,*])
          label   ='Q!Dx!N ('+string('c5'XB)+'!U-1!N)'
          end
         1:   begin
          data    =reform((*self.projStrPtr).Q[1,*,*])
          label   ='Q!Dy!N ('+string('c5'XB)+'!U-1!N)'
          end
         2:   begin
          data    =reform((*self.projStrPtr).Q[2,*,*])
          label   ='Q!Dz!N ('+string('c5'XB)+'!U-1!N)'
          end
         3:   begin
          data    =reform((*self.projStrPtr).hkl[0,*,*])
          label   ='H (rlu)'
          end
         4:   begin
          data    =reform((*self.projStrPtr).hkl[1,*,*])
          label   ='K (rlu)'
          end
         5:   begin
          data    =reform((*self.projStrPtr).hkl[2,*,*])
          label   ='L (rlu)'
          end
         6:   begin
          data    =reform((*self.projStrPtr).V[0,*,*])
          label   =self.traj_type[6]
          end
         7:   begin
          data    =reform((*self.projStrPtr).V[1,*,*])
          label   =self.traj_type[7]
          end
         8:   begin
          data    =reform(sqrt(((*self.projStrPtr).Q[0,*,*])^2+((*self.projStrPtr).Q[1,*,*])^2+$
                     ((*self.projStrPtr).Q[2,*,*])^2))
          label   ='|Q| ('+string('c5'XB)+'!U-1!N)'
          end
         9:   begin
          data    =(*self.projStrPtr).two_theta#(fltarr(nfile)+1.0)
          label   ='2theta ('+string('b0'XB)+')'
          end
         10:  begin
          data    =(findgen(n2th)+1.0)#(fltarr(nfile)+1.0)
          label   ='Detector Group Number'
          end
         else:begin
          data    =(findgen(n2th)+1.0)#(fltarr(nfile)+1.0)
          label   ='None'
          end
       endcase
       end
    endcase
    count=0
    if (n_elements(range) eq 2) and (label ne 'None') then $
       if total(finite(range)) eq 2 then begin
         if range[1] ge range[0] then $
          index=where((data ge range[0]) and (data le range[1]),count)
       endif else begin
         if self.samp_typ eq 2 then index=lindgen(nfile*n2th) $
         else index=lindgen(nen*n2th)
         count=1  ;not 0
       endelse
    if (count eq 0) and not keyword_set(leave_empty) then begin    ;show all data
       if self.samp_typ eq 2 then index=lindgen(nfile*n2th)  $
       else index=lindgen(nen*n2th)
    endif
    if keyword_set(debug) then begin
       print,'[[choose traj data finished in ',systime(/sec)-current,' sec.'
    endif
end