; $Id: dm_common.pro,v 1.3 2003/09/12 19:09:03 qiuym Exp $
; This program finds out the common elements in array1 and array2, which are both indices of arrays
; return -1 if no common elements(0 or positive integers) are found
; Yiming Qiu(yiming.qiu@nist.gov) 4/8/2003
function dm_common,arr1,arr2,count,no_copy=no_copy,debug=debug
	if keyword_set(debug) then current=systime(/sec)
	pos_arr1=where(arr1 ge 0,count1)
	pos_arr2=where(arr2 ge 0,count2)
	if (count1 eq 0) or (count2 eq 0) then begin
		pos_arr1=-1 & pos_arr2=-1
		count=0L	;no common elements
		if keyword_set(no_copy) then begin	;destroy arr1 and arr2
			n_arr=temporary(arr1)
			n_arr=temporary(arr2)
		endif
		if keyword_set(debug) then print,'dm_common finished in ',systime(/sec)-current,' sec.'
		return,-1L
	endif
	n_arr1	=max(arr1)
	n_arr2	=max(arr2)
	n_arr	=max([temporary(n_arr1),temporary(n_arr2)])
	tmp	=	bytarr(n_arr+1)
	if keyword_set(no_copy) then begin	;destroy arr1 and arr2 after this function
		tmp[arr1[pos_arr1]]=1b	& pos_arr1=-1
		tmp[arr2[pos_arr2]]=tmp[arr2[pos_arr2]]+1b  & pos_arr2=-1
		arr1=-1 & n_arr=temporary(arr1)
		arr2=-1 & n_arr=temporary(arr2)
	endif else begin
		tmp[arr1[pos_arr1]]=1b  & pos_arr1=-1
		tmp[arr2[pos_arr2]]=tmp[arr2[pos_arr2]]+1b & pos_arr2=-1
	endelse
	if keyword_set(debug) then print,'dm_common finished in ',systime(/sec)-current,' sec.'
	return,where(temporary(tmp) eq 2b,count)
end
