; $Id: dm_grid_ebin.pro,v 1.4 2003/09/12 19:09:03 qiuym Exp $
; rebin time channel, use idl rebin function
; parameters:
;   ebin_size:    rebin size
;   qty,err [ntchan,ndet] emean [ntchan]
;     or
;   qty[ntchan]
; keyword:
;   avgsum:     0:average 1:sum
pro dm_grid_ebin,ebin_size,qty,err,emean,debug=debug,avgsum=avgsum
    if keyword_set(debug) then begin
      print,'@@grid ebin...'
      current= systime(/sec)
    endif
    arr_size = size(qty,/dimension) & if arr_size[0] eq 0 then arr_size[0]=1
    old_size = arr_size[0]
    new_size = fix(float(arr_size[0])/ebin_size+0.999,type=3)    ;new E size
	factor0	 = old_size/new_size
	if keyword_set(avgsum) then factor1=factor0[0] else factor1=1.0
    if n_params() eq 4 then begin
       qty   = rebin(qty,new_size,arr_size[1])*factor1
       err   = sqrt(rebin(err^2,new_size,arr_size[1])/factor0)*factor1
       emean = rebin(emean,new_size)
    endif else if n_params() eq 2 then $
       qty   = rebin(qty,new_size)*factor1

    if keyword_set(debug) then begin
       print,'@@grid ebin finished in ',systime(/sec)-current,' sec.'
    endif
end