; $Id: dm_load_parameter.pro,v 1.13.2.1 2003/12/18 15:08:01 azuah Exp $
; load parameter file
pro dcs_mslice::dm_load_parameter,parmfile,debug=debug
    WIDGET_CONTROL,/HOURGLASS
    openr,unit,parmfile,/get_lun
    tmp=''
    old_samptyp    =  self.samp_typ
    ptr_free,self.absp_info         ;clear any existing self-shielding information
    while(not eof(unit)) do begin
       readf,unit,tmp
       head=strmid(tmp,0,8)
       tmp   =strmid(tmp,8,strlen(tmp)-8)
       case head of
         'sshield:':self.absp_info    = ptr_new(dm_to_number(strsplit(tmp,'&',/extract,/preserve)))
         'edep_yn:':self.edep_yn      = dm_to_number(tmp,/int)
         'selfshd:':self.ssfac        = dm_to_number(tmp,/float)
         'datadir:':if not keyword_set(debug) then self.fileSel->set_path,tmp
         'viewwin:':self.view[0:2]    = dm_to_number(strsplit(tmp,'&',/extract,/preserve))
         'samptyp:':begin
                    tmpvalue          = dm_to_number(tmp,/int)
                    if self.samp_typ ne tmpvalue then self.samp_typ=tmpvalue
                    end
         'intnlab:':self.intn_lab     = tmp
         'intntyp:':self.intn_typ     = dm_to_number(tmp,/int)
         'ebinsiz:':self.e_bin        = dm_to_number(strsplit(tmp,'&',/extract,/preserve),/int)
         'e_range:':self.e_range      = dm_to_number(strsplit(tmp,'&',/extract,/preserve))
         'mon_fit:':self.mon_sumfit   = dm_to_number(tmp,/int)
         'ortharb:':self.view_ortharbi= dm_to_number(tmp,/int)
         'latt__a:':self.latt_parm[0] = dm_to_number(tmp,/double)
         'latt__b:':self.latt_parm[1] = dm_to_number(tmp,/double)
         'latt__c:':self.latt_parm[2] = dm_to_number(tmp,/double)
         'latt_aa:':self.latt_parm[3] = dm_to_number(tmp,/double)
         'latt_bb:':self.latt_parm[4] = dm_to_number(tmp,/double)
         'latt_cc:':self.latt_parm[5] = dm_to_number(tmp,/double)
         'orie_ux:':self.orie_u[0]    = dm_to_number(tmp,/float)
         'orie_uy:':self.orie_u[1]    = dm_to_number(tmp,/float)
         'orie_uz:':self.orie_u[2]    = dm_to_number(tmp,/float)
         'orie_vx:':self.orie_v[0]    = dm_to_number(tmp,/float)
         'orie_vy:':self.orie_v[1]    = dm_to_number(tmp,/float)
         'orie_vz:':self.orie_v[2]    = dm_to_number(tmp,/float)
         'oriepsi:':self.orie_psi     = dm_to_number(tmp,/float)
         'view1tp:':self.view_u1typ   = dm_to_number(tmp,/float)
         'view2tp:':self.view_u2typ   = dm_to_number(tmp,/float)
         'viewu1h:':self.view_u1[0]   = dm_to_number(tmp,/float)
         'viewu1k:':self.view_u1[1]   = dm_to_number(tmp,/float)
         'viewu1l:':self.view_u1[2]   = dm_to_number(tmp,/float)
         'viewu1e:':self.view_u1[3]   = dm_to_number(tmp,/float)
         'view1lb:':self.view_u1lab   = strsplit(tmp,'&',/extract,/preserve_null)
         'viewu2h:':self.view_u2[0]   = dm_to_number(tmp,/float)
         'viewu2k:':self.view_u2[1]   = dm_to_number(tmp,/float)
         'viewu2l:':self.view_u2[2]   = dm_to_number(tmp,/float)
         'viewu2e:':self.view_u2[3]   = dm_to_number(tmp,/float)
         'view2lb:':self.view_u2lab   = strsplit(tmp,'&',/extract,/preserve_null)
         'viewu3h:':self.view_u3[0]   = dm_to_number(tmp,/float)
         'viewu3k:':self.view_u3[1]   = dm_to_number(tmp,/float)
         'viewu3l:':self.view_u3[2]   = dm_to_number(tmp,/float)
         'viewu3e:':self.view_u3[3]   = dm_to_number(tmp,/float)
         'view3lb:':self.view_u3lab   = tmp
         'dispper:':self.disp_perp    = dm_to_number(tmp,/int)
         'disptfr:':self.disp_tran[0] = dm_to_number(tmp,/float)
         'disptto:':self.disp_tran[1] = dm_to_number(tmp,/float)
         'dispfld:':self.disp_fold    = dm_to_number(tmp,/int)
         'disphfr:':self.disp_hran[0] = dm_to_number(tmp,/float)
         'disphto:':self.disp_hran[1] = dm_to_number(tmp,/float)
         'disphst:':self.disp_hstep   = dm_to_number(tmp,/float)
         'dispvfr:':self.disp_vran[0] = dm_to_number(tmp,/float)
         'dispvto:':self.disp_vran[1] = dm_to_number(tmp,/float)
         'dispvst:':self.disp_vstep   = dm_to_number(tmp,/float)
         'dispifr:':self.disp_iran[0] = dm_to_number(tmp,/float)
         'dispito:':self.disp_iran[1] = dm_to_number(tmp,/float)
         'dispsmo:':self.disp_smooth  = dm_to_number(tmp,/int)
         'dispker:':self.disp_sm_kernel[0:8] = dm_to_number(strsplit(tmp,'&',/extract,/preserve))
         'dispsha:':self.disp_shading = dm_to_number(tmp,/int)
         'dispcol:':self.disp_color   = dm_to_number(tmp,/int)
         'cut___x:':self.cut_x        = dm_to_number(strsplit(tmp,'&',/extract,/preserve),/int)
         'cut__fr:':self.cut_ran[0]   = dm_to_number(tmp,/float)
         'cut__to:':self.cut_ran[1]   = dm_to_number(tmp,/float)
         'cut__st:':self.cut_step     = dm_to_number(tmp,/float)
         'cutt1fr:':self.cut_t1ran[0] = dm_to_number(tmp,/float)
         'cutt1to:':self.cut_t1ran[1] = dm_to_number(tmp,/float)
         'cutt2fr:':self.cut_t2ran[0] = dm_to_number(tmp,/float)
         'cutt2to:':self.cut_t2ran[1] = dm_to_number(tmp,/float)
         'cut___y:':self.cut_y        = dm_to_number(strsplit(tmp,'&',/extract,/preserve),/int)
         'cut_yfr:':self.cut_yran[0]  = dm_to_number(tmp,/float)
         'cut_yto:':self.cut_yran[1]  = dm_to_number(tmp,/float)
         'cut_sym:':self.cut_symbol   = dm_to_number(tmp,/int)
         'cut_col:':self.cut_color    = dm_to_number(tmp,/int)
         'cutline:':self.cut_line     = dm_to_number(tmp,/int)
         'cuttype:':self.cut_type     = dm_to_number(tmp,/int)
         'cutname:':self.cut_name     = tmp
         'traj__x:':self.traj_x       = dm_to_number(strsplit(tmp,'&',/extract,/preserve),/int)
         'traj_xf:':self.traj_xran[0] = dm_to_number(tmp,/float)
         'traj_xt:':self.traj_xran[1] = dm_to_number(tmp,/float)
         'traj__y:':self.traj_y       = dm_to_number(strsplit(tmp,'&',/extract,/preserve),/int)
         'traj_yf:':self.traj_yran[0] = dm_to_number(tmp,/float)
         'traj_yt:':self.traj_yran[1] = dm_to_number(tmp,/float)
         'traj__z:':self.traj_z       = dm_to_number(strsplit(tmp,'&',/extract,/preserve),/int)
         'traj_zf:':self.traj_zran[0] = dm_to_number(tmp,/float)
         'traj_zt:':self.traj_zran[1] = dm_to_number(tmp,/float)
         else:
       endcase
    endwhile
    free_lun,unit
    ptr_free,self.projStrPtr
    if not keyword_set(debug) then begin
       self->my_widget_control,'showPowder',sensitive=(self.samp_typ eq 2)
       self->my_widget_control,'vaxisMenu', sensitive=(self.samp_typ ne 1)
       binSum   =   widget_info(self.tlb,find_by_uname='binSum')
       binAvg   =   widget_info(self.tlb,find_by_uname='binAvg')
       monSum   =   widget_info(self.tlb,find_by_uname='monSum')
       monFit   =   widget_info(self.tlb,find_by_uname='monFit')
       intnTyp0 =   widget_info(self.tlb,find_by_uname='intnTyp0')
       intnTyp1 =   widget_info(self.tlb,find_by_uname='intnTyp1')
       intnTyp2 =   widget_info(self.tlb,find_by_uname='intnTyp2')
       viewOrth =   widget_info(self.tlb,find_by_uname='vaxisOrtho')
       viewArbi =   widget_info(self.tlb,find_by_uname='vaxisArbi')
       abspNon  =   widget_info(self.tlb,find_by_uname='abspNone')
       abspAnn  =   widget_info(self.tlb,find_by_uname='abspAnnulus')
       abspCyl  =   widget_info(self.tlb,find_by_uname='abspCylinder')
       abspSph  =   widget_info(self.tlb,find_by_uname='abspSphere')
       if ptr_valid(self.absp_info) then begin
            case (*(self.absp_info))[0] of
                0:      dm_toggle_menubut,abspCyl,[abspNon,abspAnn,abspSph]
                1:      dm_toggle_menubut,abspAnn,[abspNon,abspCyl,abspSph]
                2:      dm_toggle_menubut,abspSph,[abspNon,abspCyl,abspAnn]
                else:   dm_toggle_menubut,abspNon,[abspCyl,abspAnn,abspSph]
            endcase
       endif else       dm_toggle_menubut,abspNon,[abspCyl,abspAnn,abspSph]
       if self.samp_typ eq 2 then begin
            self.bin_avgsum= 1
            dm_toggle_menubut,binSum,binAvg
            if self.intn_typ eq 1 then self.intn_typ=0
            widget_control,intnTyp1,sensitive=0
       endif else begin
            self.bin_avgsum=0
            dm_toggle_menubut,binAvg,binSum
            widget_control,intnTyp1,sensitive=1
       endelse
       case self.intn_typ of
            0:   dm_toggle_menubut,intnTyp0,[intnTyp1,intnTyp2]
            1:   dm_toggle_menubut,intnTyp1,[intnTyp2,intnTyp0]
            2:   dm_toggle_menubut,intnTyp2,[intnTyp0,intnTyp1]
       endcase
       if self.mon_sumfit eq 0    then dm_toggle_menubut,monSum,monFit     else dm_toggle_menubut,monFit,monSum
       if self.view_ortharbi eq 0 then dm_toggle_menubut,viewOrth,viewArbi else dm_toggle_menubut,viewArbi,viewOrth
       dm_set_button,widget_info(self.tlb,find_by_uname='viewProj'),self.view[0],onstring='Hide Projection',offstring='Show Projection'
       dm_set_button,widget_info(self.tlb,find_by_uname='viewDisp'),self.view[1],onstring='Hide Display',offstring='Show Display'
       dm_set_button,widget_info(self.tlb,find_by_uname='viewTraj'),self.view[2],onstring='Hide Trajectory',offstring='Show Trajectory'
       dm_set_button,widget_info(self.tlb,find_by_uname='edepEff'), self.edep_yn,$
         onstring='E-Dependent Detector Efficiency Correction Enabled',offstring='E-Dependent Detector Efficiency Correction Disabled'
       self->reset_file
       self->reset_pdt
    endif
end