; $Id: dm_load_spe.pro,v 1.3 2003/10/16 18:48:42 qiuym Exp $
; load spe file
pro dcs_mslice::dm_load_spe
    file=dm_dialog_input(['spe file:','phx file:'],xsize=150,/browse,filter=['*.spe','*.phx'],dialog_parent=self.tlb)
    widget_control,/HOURGLASS
    openr,unit,file[0],/get_lun,error=error
    if error ne 0 then begin
       ok=dialog_message("Can't read file "+file+'.',dialog_parent=self.tlb)
       return
    endif
    mesg =widget_base(title='Loading data ...',/col,/base_align_center,group_leader=self.tlb)
    label=widget_label(mesg,value='Loading '+file[0]+'. Please wait ...',/dynamic_resize,/align_center)
    dm_center_kid,mesg,self.tlb
    widget_control,mesg,/realize,map=1
    ndet=0L & nen=0L &junk=' ' &temp1=' '
    readf,unit,ndet,nen
    qty    =  fltarr(nen,ndet)
    err    =  fltarr(nen,ndet)
    tth    =  fltarr(ndet+1)
    dtth   =  fltarr(ndet)
    psi    =  fltarr(ndet)
    dpsi   =  fltarr(ndet)
    en     =  fltarr(nen+1)
    readf,unit,junk    ;read ### phi grid
    ;readf,unit,tth
    for i=0L,(ndet+8)/8-1 do begin
       readf,unit,junk
       for j=0,7 do begin
         temp1=strmid(junk,10*j,10)
         if strlen(temp1) eq 0 then break
         tth[8*i+j]=dm_to_number(temp1)
       endfor
    endfor
    readf,unit,junk    ;read ### Energy Grid
    ;readf,unit,en
    for i=0L,(nen+8)/8-1 do begin
       readf,unit,junk
       for j=0,7 do begin
         temp1=strmid(junk,10*j,10)
         if strlen(temp1) eq 0 then break
         en[8*i+j]=dm_to_number(temp1)
       endfor
    endfor
    tth=tth[0:ndet-1]
    en =en[0:nen-1]
    for i=0L,ndet-1L do begin
       readf,unit,junk   ;read ### S(phi,w)
       for j=0L,(nen+7)/8-1 do begin
         readf,unit,junk
         for k=0,7 do begin
          temp1=strmid(junk,10*k,10)
          if strlen(temp1) eq 0 then break
          qty[8*j+k,i]=dm_to_number(temp1)
         endfor
       endfor
       readf,unit,junk   ;read ### Errors
       for j=0L,(nen+7)/8-1 do begin
         readf,unit,junk
         for k=0,7 do begin
          temp1=strmid(junk,10*k,10)
          if strlen(temp1) eq 0 then break
          err[8*j+k,i]=dm_to_number(temp1)
         endfor
       endfor
    endfor
    free_lun,unit
    openr,unit,file[1],/get_lun,error=error
    if error eq 0 then begin   ;read phx file
       widget_control,label,set_value='Loading '+file[1]+'. Please wait ...'
       new_ndet=0L
       readf,unit,new_ndet
       if new_ndet eq ndet then begin
         tmp=fltarr(7,ndet)
         readf,unit,tmp
         tth=reform(tmp[2,*])
         psi=reform(tmp[3,*])
         dtth=reform(tmp[4,*])
         dpsi=reform(tmp[5,*])
       endif
       free_lun,unit
    endif
    widget_control,mesg,/destroy
    ;save data and det info in pointers
    ptr_free,self.detPosPtr,self.dataStrPtr
    self.detPosPtr=ptr_new({two_theta:temporary(tth),dtwo_theta:temporary(dtth),psi:temporary(psi),dpsi:temporary(dpsi)})
    self.dataStrPtr=ptr_new({qty:temporary(qty),err:temporary(err),e:temporary(en),ei:!values.f_nan})
    self.is_dcs=0
    self.bgrate=!values.f_nan
    ptr_free,self.bgdata,self.eff,self.mask
    mkcnBut =   widget_info(self.tlb,find_by_uname='mkcnBut')
    mkloBut =   widget_info(self.tlb,find_by_uname='mkloBut')
    mkupBut =   widget_info(self.tlb,find_by_uname='mkupBut')
    dm_toggle_menubut,mkcnBut,[mkcnBut,mkloBut,mkupBut] ;disable mask up,low,bottom function
    self->my_widget_control,'bgclBut',sensitive=0
    self->my_widget_control,'vdclBut',sensitive=0
    self->my_widget_control,'mkclBut',sensitive=0
end