; $Id: dm_plot_cut.pro,v 1.13 2003/09/24 20:03:02 qiuym Exp $
; plot the cut and save the data in a file if wanted
pro dcs_mslice::dm_plot_cut,overplot=overplot
    if (not ptr_valid(self.projStrPtr)) or (not ptr_valid(self.dataStrPtr)) or self.error then begin
       ok=dialog_message('Please load data and calculate projection first.',dialog_parent=self.tlb)
       return
    endif
    ;select data
    self->dm_choose_cutdata,xdat=xdat,ydat=ydat,yerr=yerr,xtit=xtit,ytit=ytit,ylog=ylog
    ;save cut
    if strlen(self.cut_name) ne 0 then begin
       tmp=strsplit(self.cut_name,'.',/extract)
       if n_elements(tmp) eq 1 then self.cut_name=self.cut_name+$
         self.filetype[self.cut_type]
       ok    =  file_test(self.cut_name)
       if ok then begin
         ans=dialog_message('File exists. Do you want to overwrite it?',/question,dialog_parent=self.tlb)
         if ans eq 'No' then begin
          self.cut_name=dialog_pickfile(dialog_parent=self.tlb,/write,filter=self.filetype[self.cut_type])
          if strlen(self.cut_name) eq 0 then $
              self.cut_name='mslice_cut'+self.filetype[self.cut_type]
         endif
       endif
       openw,unit,self.cut_name,/get_lun,error=openerr
       if openerr ne 0 then begin
         ok=dialog_message("Can't write in "+self.cut_name+'.',/error,dialog_parent=self.tlb)
       endif else begin
         for i=0,n_elements(xdat)-1 do begin
          if n_elements(yerr) ne 0 then printf,unit,xdat[i],ydat[i],yerr[i] $
          else printf,unit,xdat[i],ydat[i]
         endfor
         free_lun,unit
       endelse
    endif
    ;y range
    yran=self.cut_yran
    if finite(yran[0]) eq 0 then begin
       yran[0]=min(ydat)
       yran[0]=yran[0]-0.1*abs(yran[0])
    endif
    if finite(yran[1]) eq 0 then begin
       yran[1]=max(ydat)
       yran[1]=yran[1]+0.1*abs(yran[1])
    endif
    symbol =   strsplit(self.symbols[self.cut_symbol],' ',/extract)
    symbol =   symbol[0] & if symbol eq 'no' then symbol='no symbol'
    obj_name=  'dm_plot'
    if not obj_valid(self.current) then begin
       self.current=obj_new(obj_name,xdat,ydat,yerr=yerr,xtit=xtit,ytit=ytit,$
         group_leader=self.tlb,linestyle=self.lines[self.cut_line],$
         psym=symbol,color=self.colors[self.cut_color],ylog=ylog,$
         xran=self.cut_ran,yran=yran,title=self.titl_lab,/no_copy,legend=self.legd_lab)
    endif else begin
        self.current->getproperty,keep=keep
       if keep eq 1 then begin
         self.current=obj_new(obj_name,group_leader=self.tlb,ylog=ylog)
       endif
       if keyword_set(overplot) then $
         self.current->add_plot,xdat,ydat,yerr=yerr,/no_copy,legend=self.legd_lab,$
         color=self.colors[self.cut_color],psym=symbol,linestyle=self.lines[self.cut_line] $
       else $
         self.current->setproperty,xdat=xdat,ydat=ydat,yerr=yerr,xtit=xtit,/no_copy,legend=self.legd_lab,$
             ytit=ytit,xran=self.cut_ran,yran=yran,color=self.colors[self.cut_color],$
         psym=symbol,linestyle=self.lines[self.cut_line],title=self.titl_lab,ylog=ylog,/nodraw,hidelegend=0
    endelse
    if keyword_set(overplot) then $
       self->dm_add_plotwindow,type=1,title=self.titl_lab+'[overplot]' $
    else $
       self->dm_add_plotwindow,type=1,title=self.titl_lab
    self.current->draw
end