; $Id: dm_q2hkl.pro,v 1.3 2003/09/12 19:10:39 qiuym Exp $
; project Q[3,ne,ndet] onto three vectors abc_r[3,3]
function dm_q2hkl,Q,abc_r,debug=debug
	if keyword_set(debug) then begin
		print,'%%Q to hkl...'
		current=systime(/sec)
	endif
	ABC		=dm_basis_hkl(abc_r)
	Qsize	=size(Q,/dimension)
	;old and slower code
	;hkl		=fltarr(Qsize[0],Qsize[1],Qsize[2])
	;hkl[0,*,*]	=Q[0,*,*]*ABC[0,0]+Q[1,*,*]*ABC[1,0]+Q[2,*,*]*ABC[2,0]
	;hkl[1,*,*]	=Q[0,*,*]*ABC[0,1]+Q[1,*,*]*ABC[1,1]+Q[2,*,*]*ABC[2,1]
	;hkl[2,*,*]	=Q[0,*,*]*ABC[0,2]+Q[1,*,*]*ABC[1,2]+Q[2,*,*]*ABC[2,2]
	if n_elements(Qsize) eq 2 then $
		Qsize=[Qsize,1]
	tmp		=reform(Q,3,Qsize[1]*Qsize[2])
	hkl		=temporary(tmp)##transpose(ABC)
	if Qsize[2] ne 1 then $
		hkl		=reform(hkl,3,Qsize[1],Qsize[2])
	if keyword_set(debug) then begin
		print,'%%Q to hkl finished in ',systime(/sec)-current,' sec.'
	endif
	return,hkl
end