; $Id: dm_to_fit.pro,v 1.6 2003/09/26 18:54:08 qiuym Exp $
; sent the cut data to PAN for fitting
pro dcs_mslice::dm_to_fit
    if (not ptr_valid(self.projStrPtr)) or (not ptr_valid(self.dataStrPtr)) or self.error then begin
       ok=dialog_message('Please load data and calculate projection first.',dialog_parent=self.tlb)
       self.error=1
       return
    endif
    opan=0
    ;error handling
    catch, myerror
    if myerror ne 0 then begin
       catch,/cancel
       ok=dialog_message(dialog_parent=self.tlb,!error_state.msg,/error)
       if obj_valid(opan) then obj_destroy,opan
       return
    end
    ;select data
    self->dm_choose_cutdata,xdat=xdat,ydat=ydat,yerr=yerr,xtit=xtit,ytit=ytit
    ;save cut
    if strlen(self.cut_name) ne 0 then begin
       tmp=strsplit(self.cut_name,'.',/extract)
       if n_elements(tmp) eq 1 then self.cut_name=self.cut_name+$
         self.filetype[self.cut_type]
       ok=file_test(self.cut_name)
       if ok then begin
         ans=dialog_message('File exists. Do you want to overwrite it?',/question,dialog_parent=self.tlb)
         if ans eq 'No' then begin
          self.cut_name=dialog_pickfile(dialog_parent=self.tlb,/write,filter=self.filetype[self.cut_type])
          if strlen(self.cut_name) eq 0 then $
              self.cut_name='mslice_cut'+self.filetype[self.cut_type]
         endif
       endif
       openw,unit,self.cut_name,/get_lun,error=openerr
       if openerr ne 0 then begin
         ok=dialog_message("Can't write in "+self.cut_name+'.',/error,dialog_parent=self.tlb)
       endif else begin
         for i=0,n_elements(xdat)-1 do begin
         if n_elements(yerr) ne 0 then printf,unit,xdat[i],ydat[i],yerr[i] $
         else printf,unit,xdat[i],ydat[i]
         endfor
         free_lun,unit
       endelse
    endif
    ;to PAN
    if n_elements(yerr) ne n_elements(ydat) then begin
       ok  =dialog_message('No yerr. 0.1*y is used as yerr.',dialog_parent=self.tlb)
       yerr=0.1*ydat
    endif
    opan=obj_new('opan',mydata=ydat,error=yerr,xvalues=xdat,yvalues=0,group_leader=self.tlb)
end