; $Id: davedat1d__restore.pro,v 1.4 2003/02/21 22:58:11 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST
;
; NAME:_______________________
;   DaveDat1D::restore
;
; PURPOSE:____________________
;   This function is used to 
;   restore all class variables derived from the davePtr back to
;   their initial values. The davePtr class variables always contains
;   the original data.
;
; INPUTS:_____________________
;   NONE
;
; OUTPUTS:____________________
;     return value: 0 signifies failure and 1 success.
;
function DaveDat1D::restore

retVal = self->resetData()

if (retVal eq 0) then return, retVal

; ensure data is 1D and not 2D
if (ptr_valid(self.zvPtr)) then begin
    if ((size(*(self.zvPtr)))[0] gt 1) then begin
        *(self.zvPtr) = (*(self.zvPtr))[*,1]
    endif
endif
if (ptr_valid(self.zePtr)) then begin
    if ((size(*(self.zePtr)))[0] gt 1) then begin
        *(self.zePtr) = (*(self.zePtr))[*,1]
    endif
endif

return, retVal

end
