; $Id: davegr1d__resetlegend.pro,v 1.1 2003/08/14 20:51:36 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST
;
; NAME:_______________________
;   DaveGr1D::resetLegend
;
; PURPOSE:____________________
;   Private method to initialize/reset legend prpoerties.
;
; INPUTS:_____________________
;   KEYWORDS
;   None.
;
pro DaveGr1D::resetLegend

message,/reset

self.legend.bkgdColor = [192,192,192]
self.legend.font = 'HELVETICA'
self.legend.fontsize = 8.0
self.legend.tFont = 'HELVETICA'
self.legend.tFontsize = 11.0
self.legend.title = 'Legend'
self.legend.tColor = [0,0,0]
self.legend.gap = 0.5
self.legend.gWidth = 2.5
self.legend.hideFlag = 0
self.legend.fillFlag = 1
self.legend.outlFlag = 1
self.legend.outlColor = [128,0,0]
self.legend.outlThick = 1.0
self.legend.textColor = [0,0,0]
self.legend.location = [0.7,0.65]

nData = self->count()
if (nData le 0) then return
if (not self->get(dataRef=dataRef)) then return
for i=0, nData-1 do begin
    self.legend.itemThick[i] = 1.0
    if (not (dataRef[i])->get(nameTag=nameTag)) then return
    self.legend.itemName[i] = nameTag
endfor

end
