; $Id: davegr__add.pro,v 1.2 2003/07/11 19:25:42 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST
;
; NAME:_______________________
;   DaveGr::add
;
; PURPOSE:____________________
;   DaveGr is derived from IDL_Container
;   Overide IDL_Container add method which adds an object to
;   this object's internal container. However we need to record
;   this addition by modified the object being added.
;
; INPUTS:_____________________
;   PARAMETERS:
;     objRef: the object reference to be added
;
;   None.
;
pro DaveGr::add, objRef, _EXTRA=etc

; Increment the (data) object's internal reference counter by 1
nObj = n_elements(objRef)
if (nObj gt 0) then begin
    for i=0,nObj-1 do begin
        void = (objRef[i])->set(/addRef)
    endfor
endif

self->IDL_CONTAINER::add, objRef, _EXTRA=etc

; update graph attribute limits 
self->resetMiscGrAttribs, /limits

end
