; $Id: davegr__remove.pro,v 1.1 2003/03/14 18:59:32 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST
;
; NAME:_______________________
;   DaveGr::remove
;
; PURPOSE:____________________
;   DaveGr is derived from IDL_Container
;   Overide IDL_Container remove method which removes an object from
;   the object's internal container. However we first need to make
;   some changes to the contained object before removal.
;
; INPUTS:_____________________
;   PARAMETERS:
;     objRef: the object reference to be removed from the container
;
;   None.
;
pro DaveGr::remove, objRef, position=pos, all=all, _EXTRA=etc

; if object is passed as a parameter
if (n_elements(objRef) gt 0) then begin
    for i=0,n_elements(objRef)-1 do begin
        void = (objRef[i])->set(/remRef) ; decrement object's int. ref. by 1
    endfor

    self->IDL_CONTAINER::remove, objRef, _EXTRA=etc
endif

; if object is passed using its position in the container
if (n_elements(pos) gt 0) then begin
    oRef = self->IDL_CONTAINER::get(position=pos)
    void = oRef->set(/remRef)   ; decrement object's int. ref. by 1

    self->IDL_CONTAINER::remove, position=pos, _EXTRA=etc
endif

; All objects are to be removed
if (keyword_set(all)) then begin
    oRef = self->IDL_CONTAINER::get(/all,count=nObj)

    for i=0,nObj-1 do begin
        void = (oRef[i])->set(/remRef) ; decrement object's int. ref. by 1
    endfor

    self->IDL_CONTAINER::remove, /all, _EXTRA=etc

endif

end
