; $Id: object_registry__define.pro,v 1.3 2003/02/25 14:54:46 azuah Exp $
;+
; NAME:
;       OBJECT_REGISTRY__DEFINE
;
; PURPOSE:
;
;       This class definition allows the user to register widget object programs
;		with it and, whenever anything changes to the data, a REFRESH method is
;		invoked and all such widget object programs registered are updated
;		simultaneously.
;
;
; AUTHOR:
;
;       Robert M. Dimeo, Ph.D.
;		NIST Center for Neutron Research
;       100 Bureau Drive
;		Gaithersburg, MD 20899
;       Phone: (301) 975-8135
;       E-mail: robert.dimeo@nist.gov
;       http://www.ncnr.nist.gov/staff/dimeo
;
; CATEGORY:
;
;       Objects, DAVE
;
; CALLING SEQUENCE:
;
;       O_REG = OBJ_NEW('OBJECT_REGISTRY')
;
; SYSTEM REQUIREMENTS
;
;		NONE
;
; REQUIRED PROGRAMS
;
;		NONE
;
;
; DISCLAIMER
;
;		This software is provided as is without any warranty whatsoever.
;		Permission to use, copy, modify, and distribute modified or
;		unmodified copies is granted, provided this disclaimer
;		is included unchanged.
;
; MODIFICATION HISTORY:
;
;       Written by Rob Dimeo, February 19, 2003.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro object_registry::cleanup
self->IDL_CONTAINER::cleanup
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro object_registry::refresh,_Extra = extra
nobj = self->count()
if nobj eq 0 then return
oall = self->get(/all)
for i = 0,nobj-1 do begin
;  r = execute('oall[i]->refresh,_Extra = extra',1)
    oall[i]->refresh,_Extra = extra
endfor
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function object_registry::init
retval = self->IDL_CONTAINER::init()
return,retval
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro object_registry__define
define =	{	object_registry,		$
				inherits IDL_CONTAINER	$
			}

end
