; $Id: db_get_new_name.pro,v 1.5 2003/04/09 17:37:50 azuah Exp $
;+
; NAME:
;       DB_GET_NEW_NAME
;
; PURPOSE:
;
;       This is the main interface for the DAVE Data Browser.
;
;
; AUTHOR:
;
;       Robert M. Dimeo, Ph.D.
;		NIST Center for Neutron Research
;       100 Bureau Drive
;		Gaithersburg, MD 20899
;       Phone: (301) 975-8135
;       E-mail: robert.dimeo@nist.gov
;       http://www.ncnr.nist.gov/staff/dimeo
;
; CATEGORY:
;
;       Widgets, DAVE
;
; CALLING SEQUENCE:
;
;       STRUCTURE = DB_GET_NEW_NAME(GROUP_LEADER = group_leader,NAME)
;
; RETURNS
;
;		Returns a two-element structure:
;
;			STRUCTURE = {NAME:name,CANCEL:cancel}
;
; REQUIRED PROGRAMS
;
;		NONE
;
;
; DISCLAIMER
;
;		This software is provided as is without any warranty whatsoever.
;		Permission to use, copy, modify, and distribute modified or
;		unmodified copies is granted, provided this disclaimer
;		is included unchanged.
;
; MODIFICATION HISTORY:
;
;       Written by Rob Dimeo, February 24, 2003.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro db_gnn_event,event
widget_control,event.top,get_uvalue = pState
field_id = widget_info(event.top,find_by_uname = 'NAME_FIELD')
uname = widget_info(event.id,/uname)
case uname of
'NAME_FIELD':	$
	begin
		widget_control,field_id,get_value = value
		(*pState).new_name = value[0]
	end
'ACCEPT':	$
	begin
		widget_control,field_id,get_value = value
		(*pState).new_name = value[0]
                widget_control,event.top,/destroy
	end
'CANCEL':	$
	begin
		(*pState).cancel = 1
                widget_control,event.top,/destroy
	end
else:
endcase

end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function db_get_new_name,GROUP_LEADER =group_leader,name
new_name = name

if (n_elements(group_leader) eq 0) then begin
    group_leader = 0L
    modal = 0
    tlb = widget_base(tlb_frame_attr=1,title='New Label',/col)
endif else begin
    modal = 1
    tlb = widget_base(group_leader=group_leader,tlb_frame_attr=1,modal=modal,title='New Label',/col)
endelse

field = cw_field(tlb,value = name,uname = 'NAME_FIELD',title = 'NAME',/return_events)
row_base = widget_base(tlb,/row,/align_center)
void = widget_button(row_base,value = 'Accept',uname = 'ACCEPT')
void = widget_button(row_base,value = 'Cancel',uname = 'CANCEL')

widget_control,tlb,/realize
state = { name:name, cancel:0, new_name:name }
pState = ptr_new(state)
widget_control,tlb,set_uvalue = pState
xmanager,'db_gnn',tlb,no_block=modal,event_handler = 'db_gnn_event'
new_name = (*pState).new_name
cancel = (*pState).cancel
ptr_free,pState
return,{name:new_name,cancel:cancel}
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
