; $Id: ref_delta.pro,v 1.3 2003/05/19 17:32:24 dimeo Exp $
; This function returns the resolution function, normalized to unit area,
; evaluated over the range of x but whose center is located at CENTER.
function ref_delta,xvals,center,resolution,_Extra = extra
if n_params() ne 3 then return,0
nx = extra.nx & ny = extra.ny
x = xvals[0:nx-1] & y = xvals[nx:nx+ny-1]
dx = x[1]-x[0]
wh = where(center eq 0.0,count_zero,complement = ok,ncomplement = nok)
nshift = 0*center
if nok gt 0 then nshift[ok] = fix(center[ok]/dx)+abs(center[ok])/center[ok]
;if center ne 0.0 then begin
;  nshift = fix(center/dx)+abs(center)/center
;endif else begin
;  nshift = 0
;endelse
yout = resolution
; Normalize the resolution function
for i = 0,ny-1 do begin
	area = int_tabulated(x,resolution[*,i])
	yout[*,i] = shift(resolution[*,i]/area,nshift[0,i])
endfor

return,yout
end
