; $Id: ref_gaussian.pro,v 1.2 2003/05/19 17:32:24 dimeo Exp $
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function ref_gaussian,xvals,parms,								$
                    	parmnames = parmnames,					$
                    	init_guess = init_guess,				$
                    	qty = qty,								$
                    	single_parmnames = single_parmnames,	$
                    	multi_parmnames = multi_parmnames,		$
                    	all_y = all_y,							$
                    	res_ptr = res_ptr,						$
                    	step = step,							$
                    	_Extra = extra
nx = extra.nx & ny = extra.ny
x = xvals[0:nx-1] & y = xvals[nx:nx+ny-1]
ux = 1+bytarr(nx) & uy = 1+bytarr(ny)

if (n_params() eq 0) or (n_params() eq 1) then begin
	areastr = 'area:'+strtrim(string(indgen(extra.ny)),2)
	centerstr = 'center:'+strtrim(string(indgen(extra.ny)),2)
	fwhmstr = 'fwhm:'+strtrim(string(indgen(extra.ny)),2)
	parmnames = [areastr,centerstr,fwhmstr]
	single_parmnames = ''
	multi_parmnames = ['area:','center:','fwhm:']
	step = dblarr(3*ny)
	if arg_present(init_guess) then begin
		intensity = max(qty,dimension = 1,index)
		qty_size = size(qty)
		for i = 0,qty_size[2]-1 do begin
			qty_max = max(qty[*,i],index)
			if i eq 0 then index_array = index else $
				index_array = [index_array,index]
		endfor
		center = x[index_array]
		; Guess the 1/2 width at the highest y-value
		; Get the low value first
		amp = max(qty[*,qty_size[2]-2])
		ht = 0.5*amp
		wh_lo = where(abs(amp-ht) le min(abs(amp-ht)) and (x lt 0.0),count_lo)
		x_lo_lim = x[wh_lo[0]]
 		wh_hi = where(abs(amp-ht) le min(abs(amp-ht)) and (x gt 0.0),count_hi)
		x_hi_lim = x[wh_hi[0]]
		fwhm = (x_hi_lim - x_lo_lim)
		sig = fwhm/2.354
		init_guess = [sqrt(2.0*!dpi)*sig*intensity,center,transpose(fwhm#uy)]
	endif

	return,-1
endif

area = parms[0:ny-1]
center = parms[ny:2*ny-1]
sig = (parms[2*ny:3*ny-1])/2.354

dx = (moment(x[1:nx-1]-x[0:nx-2]))[0]
dy = (moment(y[1:ny-1]-y[0:ny-2]))[0]
gauss = (ux#(area/(sig*sqrt(2.0*!dpi))))*exp(-0.5*((x#uy-ux#center)/(ux#sig))^2)
yout = scat_convolve(x,y,gauss,*res_ptr)
return,yout
end