; $Id: ref_translational_diffusion.pro,v 1.2 2003/05/19 17:32:24 dimeo Exp $
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function ref_translational_diffusion,xvals,parms,				$
                    	parmnames = parmnames,					$
                    	init_guess = init_guess,				$
                    	qty = qty,								$
                    	step = step,							$
                    	single_parmnames = single_parmnames,	$
                    	multi_parmnames = multi_parmnames,		$
                    	res_ptr = res_ptr,						$
                    	all_y = all_y,							$
                    	xunits = xunits,						$
                    	_Extra = extra
; all_y keyword is relevant for this model
if n_elements(all_y) eq 0 then all_y = 1
nx = extra.nx & ny = extra.ny
x = xvals[0:nx-1] & y = xvals[nx:nx+ny-1]
ux = 1+bytarr(nx) & uy = 1+bytarr(ny)
parmnames =	['Diffusion constant', $
			'Intensity:'+strtrim(string(indgen(ny)),2), $
			'Center:'+strtrim(string(indgen(ny)),2)]
single_parmnames = parmnames[0]
multi_parmnames = ['Intensity','Center']
if arg_present(step) then begin
	step = dblarr(1+2*extra.ny)
endif
if (n_params() eq 0) or (n_params() eq 1) then begin
	if arg_present(init_guess) then begin
		intensity = max(qty,dimension = 1,index)
		qty_size = size(qty)
		for i = 0,qty_size[2]-1 do begin
			qty_max = max(qty[*,i],index)
			if i eq 0 then index_array = index else $
				index_array = [index_array,index]
		endfor
		center = x[index_array]
		; Guess the 1/2 width at the highest y-value
		; Get the low value first
		amp = max(qty[*,qty_size[2]-2])
		ht = 0.5*amp
		wh_lo = where(abs(amp-ht) le min(abs(amp-ht)) and (x lt 0.0),count_lo)
		x_lo_lim = x[wh_lo[0]]
 		wh_hi = where(abs(amp-ht) le min(abs(amp-ht)) and (x gt 0.0),count_hi)
		x_hi_lim = x[wh_hi[0]]
		fwhm = x_hi_lim - x_lo_lim
		d = 0.5*fwhm/0.6528
		if strupcase(xunits) eq 'MEV' then d = d*1.d-4 else d = d*1.d-7
		init_guess = [d,intensity,center]
	endif
  return,-1
endif

D = ux#(parms[0])#uy
if strupcase(xunits) eq 'MEV' then D = D*1.d4 else D = D*1.d7
gam = (0.6528)*D*(ux#y)^2

intensity = ux#(parms[1:1+ny-1])
center = ux#(parms[1+ny:1+2*ny-1])
lorentzian = ((gam/!dpi))/((x#uy-center)^2+(gam)^2)
lineshape = scat_convolve(x,y,lorentzian,*res_ptr)
yout = intensity*lineshape
return,yout
end