; $Id: table_lookup__define.pro,v 1.2 2003/06/02 19:11:34 dimeo Exp $
;
; Simple object class to read in and manipulate the table lookup data.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro table_lookup::cleanup
ptr_free,self.xnl_ptr,self.xnl_lptr,self.ktable_ptr
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function table_lookup::load_xnl_table
filename = 'xnl.txt'
if file_which(filename) eq '' then begin
  file = filename
endif else begin
  file = file_which(filename)
endelse
nvalues = 100
openr,lun,file,/get_lun

nbig = 100
xnl = dblarr(nbig)
l = intarr(nbig)
xx = 0.0
ll = 0
dummy = ''
for i = 0,nbig-1 do begin
  readf,lun,dummy
  reads,dummy, ll,xx
  xnl[i] = double(xx)
  l[i] = fix(ll)
endfor

free_lun,lun,/force
*self.xnl_ptr = xnl
*self.xnl_lptr = l
return,1
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function table_lookup::load_ktable
if file_which('kohlrauschtable.txt') eq '' then begin
  file = 'kohlrauschtable.txt'
endif else begin
  file = file_which('kohlrauschtable.txt')
endelse
openr, lun, file, /get_lun
   readf,lun,npts,nb,nt
   yout = dblarr(npts+1,nb+1,nt+1)
   readf, lun, yout
free_lun, lun
*self.ktable_ptr = yout
return,1
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function table_lookup::get_xnl,	xnl = xnl,	$
								l = l

if n_elements(*self.xnl_ptr) eq 0 then begin
	ret = self->load_xnl_table()
endif
xnl = *self.xnl_ptr
l = *self.xnl_lptr
return,1
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function table_lookup::is_ktable_loaded,	loaded = loaded
loaded = (n_elements(*self.ktable_ptr) ne 0)
return,1
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function table_lookup::get_ktable,	ktable_ptr = ktable_ptr,	$
									msg = msg
if n_elements(*self.ktable_ptr) eq 0 then begin
	ret = self->load_ktable()
endif
ktable_ptr = self.ktable_ptr
return,1
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function table_lookup::init
self.xnl_ptr = ptr_new(/allocate_heap)
self.xnl_lptr = ptr_new(/allocate_heap)
self.ktable_ptr = ptr_new(/allocate_heap)
return,1
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro table_lookup__define
	define =	{	table_lookup,			$
					ktable_ptr:ptr_new(),	$
					xnl_ptr:ptr_new(),		$
					xnl_lptr:ptr_new()		}
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;