; $Id: opanreadfitparmsandconstraints.pro,v 1.4 2003/10/06 18:02:16 dimeo Exp $
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro opanReadFitParmsAndConstraints,filename,fitArray = fitArray, $
   groups = groups, error = error,ermsg = ermsg
; This routine reads in a parameter file that was generated in
; OPAN.PRO.
;
error = 0
if n_params() eq 0 then begin
  fitArray = (-1)
  error = 1
  ermsg = 'No arguments supplied with function call'
  return
endif

catch,theError
if theError ne 0 then begin
  catch,/cancel
  error = 1
  ermsg = !error_state.MSG
  fitArray = (-1)
  return
endif

openr,lun,filename,/get_lun
s = ''
;readf,lun,s
ngrps = 0
nlines = 0

repeat begin

    nlines = 0

    while strpos(s,'Chi-squared:') ne 0 do begin
     readf,lun,s
     nlines = nlines + 1
        if (nlines eq 1) and (ngrps eq 0) then begin
      strout = s
        endif else begin
            strout = [strout,s]
        endelse

    endwhile

    if ngrps eq 0 then grpArray = nlines else grpArray = [grpArray,nlines]
    ngrps = ngrps + 1
   readf,lun,s
endrep until eof(lun)
free_lun,lun

; Here GRPARRAY is correct!
; print,grpArray
; Ok we now have all of the fit information in the form of strings
; Sort it all out

; Add some testing code here
;help,strout
;for j = 0,ngrps-1 do begin
;  group = j
;  case group of
;  0:     begin
;            start = 0
;            finish = start+grpArray[0]-1
;            next_start = finish+2
;         end
;  else:  begin
;            start = next_start
;            finish = start+grpArray[group]-2
;            next_start = finish+2
;         end
;  endcase
;endfor
;
;return
; End testing code

for j = 0,ngrps-1 do begin

  fitStr = {namePtr:ptr_new(/allocate_heap),    $
            parmPtr:ptr_new(/allocate_heap),    $
            parmErrPtr:ptr_new(/allocate_heap), $
            fixPtr:ptr_new(/allocate_heap),   $
            lowcheckPtr:ptr_new(/allocate_heap),   $
            highcheckPtr:ptr_new(/allocate_heap),  $
            lowvaluePtr:ptr_new(/allocate_heap),   $
            highvaluePtr:ptr_new(/allocate_heap),  $
            tiePtr:ptr_new(/allocate_heap),   $
            nparmPtr:ptr_new(/allocate_heap),   $
            chisqPtr:ptr_new(/allocate_heap),   $
            exprPtr:ptr_new(/allocate_heap) }

  if j eq 0 then fitArray = fitStr else fitArray = [fitArray,fitStr]
  parmFlag = 0
  group = j

  case group of
  0:     begin
            start = 0
            finish = start+grpArray[0]-1
            next_start = finish+2
         end
  else:  begin
            start = next_start
            finish = start+grpArray[group]-2
            next_start = finish+2
         end
  endcase

;   print,start,finish
;  start = group*grpArray[group]
;  finish = (group+1)*grpArray[group]-1

;  print,start,finish
  chi_string = strout[finish]
;  print,chi_string

  chi_col_pos = strpos(chi_string,':')
  chi_value = float(strmid(chi_string,chi_col_pos+1))
  *fitStr.chisqPtr = chi_value
  thisStrout = strout[start:finish]
  if j eq 0 then test_string = thisStrout[1] else test_string = thisStrout[0]
  colPos = strpos(test_string,':')
  grpId = fix(strmid(test_string,colPos+1))

  ; Determine how many curves there are...
  cI = where(thisStrout eq '-----------------',ncurves)
  nameIndex = cI+1
  names = strarr(ncurves)
  nparms = intarr(ncurves)
  exprArray = strarr(ncurves)
  ; What are the names of the individual curves?  What are the parameters
  ; in each of the curves?
  for inames = 0,ncurves-1 do begin

    nPos = strpos(thisStrout[nameIndex[inames]],':')
    names[inames] = strtrim('PAN_'+strtrim(strmid(thisStrout[nameIndex[inames]],nPos+1),2),2)
    if strupcase(names[inames]) eq 'PAN_USERFUNCTION' then begin
      exprArray[inames] = thisStrout[nameIndex[inames]+1]
      n1 = nameIndex[inames]+2
    endif else begin
      n1 = nameIndex[inames]+1     ; where the parameters begin
    endelse
      if inames ne ncurves-1 then begin
        n2 = nameIndex[inames+1]-2  ; where the parameters end
      endif else begin
        n2 = (finish-start) - 2   ; where the parameters end
      endelse
      nparms[inames] = n2-n1+1
      for jp = 0,nparms[inames]-1 do begin
        len = strlen(thisStrout[n1+jp])
        col1Pos = strpos(thisStrout[n1+jp],': ')
        col2Pos = col1Pos + strpos(thisStrout[n1+jp],': ',col1Pos+1)
        addPos = strpos(thisStrout[n1+jp],'+/-')
        curParms = float(strmid(thisStrout[n1+jp],col2Pos-1,addPos-col2Pos))

        comma1pos = strpos(thisStrout[n1+jp],',')
        sigmaParms = float(strmid(thisStrout[n1+jp],addPos+4,-(addPos+4)+comma1pos))

     comma2pos = strpos(thisStrout[n1+jp],',',comma1pos+1)
     curFixed = fix(strmid(thisStrout[n1+jp],comma1pos+1,comma2pos-1))
     comma3pos = strpos(thisStrout[n1+jp],',',comma2pos+1)
     curLowCheck = fix(strmid(thisStrout[n1+jp],comma2pos+1,comma3pos-1))
     comma4pos = strpos(thisStrout[n1+jp],',',comma3pos+1)
     curLowValue = float(strmid(thisStrout[n1+jp],comma3pos+1,comma4pos-1))
     comma5pos = strpos(thisStrout[n1+jp],',',comma4pos+1)
     curHighCheck = fix(strmid(thisStrout[n1+jp],comma4pos+1,comma5pos-1))
     comma6pos = strpos(thisStrout[n1+jp],',',comma5pos+1)
     curHighValue = float(strmid(thisStrout[n1+jp],comma5pos+1,comma6pos-1))
     curTie = fix(strmid(thisStrout[n1+jp],comma6pos+1))
        if (parmFlag eq 0) then begin
          outSigma = sigmaParms
          outParms = curParms
       outFixed = curFixed
       outLowCheck = curLowCheck
       outLowValue = curLowValue
       outHighCheck = curHighCheck
       outHighValue = curHighValue
       outTie = curTie
          parmFlag = 1
        endif else begin
          outSigma = [outSigma,sigmaParms]
          outParms = [outParms,curParms]
          outFixed = [outFixed,curFixed]
          outLowCheck = [outLowCheck,curLowCheck]
          outLowValue = [outLowValue,curLowValue]
          outHighCheck = [outHighCheck,curHighCheck]
          outHighValue = [outHighValue,curHighValue]
          outTie = [outTie,curTie]
        endelse

      endfor
  endfor

  *(fitArray[j]).namePtr = names
  *(fitArray[j]).parmPtr = outParms
  *(fitArray[j]).parmErrPtr = outSigma
  *(fitArray[j]).fixPtr = outFixed
  *(fitArray[j]).lowcheckPtr = outLowCheck
  *(fitArray[j]).highcheckPtr = outHighCheck
  *(fitArray[j]).lowvaluePtr = outLowValue
  *(fitArray[j]).highvaluePtr = outHighValue
  *(fitArray[j]).tiePtr = outTie
 ; *(fitArray[j]).chisqPtr = chi_value
  *(fitArray[j]).nparmPtr = nparms
  *(fitArray[j]).exprPtr = exprArray
  if j eq 0 then groups = grpId else groups = [groups,grpId]
endfor

return
end