; $Id: dave.pro,v 1.92.2.2 2004/02/20 15:38:18 azuah Exp $
; DAVE.PRO
;
;
; Data Analysis and Visualization Environment
; Version 0.01
;
; Notes for use:
; Must use batchfile called davebatch.pro in startup file so that
; proper directory structure is known.
;
; Written by R.M.Dimeo (10/22/01)
;=================================
; Modified (11/02/01) to include CNRF png file for display
; on first screen (RMD)
;
; Testing out CVS branches.  This should only appear in the
; development branch
;
; Modified (09/19/02) so that DAVE POINTER definition has
; been extended (RMD).  Also improved the cleanup routine.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro daveCleanup,tlb
widget_control,tlb,get_uvalue = pState
obj_destroy,(*(*pState).extraPtr).panInfo.panContainer

ptr_free,(*pState).extraPtr

;<<<<<<< dave.pro
;ptr_free,(*(*(*pState).davePtr).dataStrPtr).commonStr.commonStrPtr
;ptr_free,(*(*(*pState).davePtr).dataStrPtr).commonStr.histPtr
;ptr_free,(*(*(*pState).davePtr).dataStrPtr).commonStr.treatmentPtr
;ptr_free,(*(*(*pState).davePtr).dataStrPtr).specificPtr
;ptr_free,(*(*pState).davePtr).descriPtr
;ptr_free,(*(*pState).davePtr).dataStrPtr
;ptr_free,(*pState).davePtr
;heap_free,pState
;=======
;ptr_free,(*(*(*pState).davePtr).dataStrPtr).commonStr.commonStrPtr
;ptr_free,(*(*(*pState).davePtr).dataStrPtr).commonStr.histPtr
;ptr_free,(*(*(*pState).davePtr).dataStrPtr).commonStr.treatmentPtr
;ptr_free,(*(*(*pState).davePtr).dataStrPtr).specificPtr
;ptr_free,(*(*pState).davePtr).descriPtr
;ptr_free,(*(*pState).davePtr).dataStrPtr
;ptr_free,(*pState).davePtr
heap_free, (*pState).davePtr    ; RTA (Feb,03) - replace previous 7 'ptr_free' statements with one 'heap_free'
ptr_free,pState
ptr_free, !dave_defaults        ; RTA (Feb,03)
;>>>>>>> 1.70
help,/heap,/brief
temp = ptr_valid(count=nptr)
print,'Number of dangling pointers: ',nptr
managed_widgets = widget_info(/managed)
if managed_widgets[0] eq 0 then begin
  ptr_free,ptr_valid() & obj_destroy, obj_valid()
endif
temp = ptr_valid(count=nptr)
print,'Number of pointers left after cleanup: ',nptr
;if nptr eq 0 then print,'...pointers freed'

; If in the development environment, and running Windows,
; restore the launchtime current directory.
if (not lmgr(/runtime) and !version.os_family eq "Windows") then cd,!thisDir
;
;return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveQuit,event
widget_control,event.top,/destroy
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveAboutDave,event
aboutDave,group_leader = event.top
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function dave_defs_checkout,dave_defs
; These are the tag names that we currently expect to find in the structure
; "dave_defs". If there is any mismatch we proceed as though "dave_defs.sav"
; was not found.
; "WEB_BROWSER" tag added 2-4-04 (RMD)
;
;tags_expected=strupcase(["datDir","workDir","PDFReader","web_browser"])
;tags_expected=tags_expected[sort(tags_expected)]
;tags_found=strupcase(tag_names(dave_defs))
;tags_found=tags_found[sort(tags_found)]
;mismatch=n_elements(tags_found) ne n_elements(tags_expected)
;if (not mismatch) then begin
;   mismatch=total(tags_found eq tags_expected) lt n_elements(tags_found)
;endif
;if (mismatch) then x=dialog_message([$
;   "Mismatch of tags",$
;   "Found:   "+strjoin(tags_found,";"),$
;   "Expected:"+strjoin(tags_expected,";")],/error)
;return,mismatch

; RTA - revamp code to insert the necessary tags in the
;       dave_defs structure instead of simply checking.
cd,current=cwd
tags_present = strupcase(tag_names(dave_defs))
; insert 'datDir' field if necessary
void = where(tags_present eq 'DATDIR', count)
if (count le 0) then dave_defs = create_struct(dave_defs, 'datDir', cwd)
; insert 'workDir' field if necessary
void = where(tags_present eq 'WORKDIR', count)
if (count le 0) then dave_defs = create_struct(dave_defs, 'workDir', cwd)
; insert PDF Reader field if necessary
void = where(tags_present eq 'PDFREADER', count)
if (count le 0) then dave_defs = create_struct(dave_defs, 'PDFReader', '')
; insert Web Browser field if necessary
void = where(tags_present eq 'WEB_BROWSER', count)
if (count le 0) then dave_defs = create_struct(dave_defs, 'web_browser', '')

return, 0

end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;pro fdaveSelCurrentDirectory,event
;daveDeSensitizeButtons,event
;cd,current=curDir
;directory = DIALOG_PICKFILE(title = 'Select new current directory',/directory)
;if (directory ne '' and directory ne ' ') then begin
;  cd,directory
;  mismatch=1
;  if (file_test(!defaults_file)) then begin
;   restore,!defaults_file
;   dave_defs=*pdd
;   mismatch=dave_defs_checkout(dave_defs)
;  endif
;  if (mismatch) then begin
;   if (ptr_valid(pdd)) then ptr_free,pdd
;   pdd=ptr_new({datDir:directory,workDir:directory,PDFReader:''})
;  endif
;  defsysv,'!dave_defaults',pdd
;endif
;cd,current=newcurDir
;if (curDir ne newcurDir) then $
;  x=dialog_message(["The raw data directory is "+(*!dave_defaults).datDir,"",$
;   "The working directory is "+(*!dave_defaults).workDir,"",$
;   "The current directory is "+newcurDir],/information)
;daveSensitizeButtons,event
;return
;end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveSelDataDirectory,event
daveDeSensitizeButtons,event
dave_defs=*!dave_defaults
old_directory=dave_defs.datDir
directory = DIALOG_PICKFILE(title = 'Select data directory',/directory,path=old_directory)
if (directory eq '' or directory eq ' ') then begin
  daveSensitizeButtons,event
  return
endif
dave_defs.datDir=directory
pdd=!dave_defaults
ptr_free,pdd
pdd=ptr_new(dave_defs)
save,filename=!defaults_file,pdd
defsysv,'!dave_defaults',pdd
cd,current=curDir
if (old_directory ne directory) then $
   x=dialog_message(["The raw data directory is "+(*!dave_defaults).datDir,"",$
     "The working directory is "+(*!dave_defaults).workDir],$
     /information)
daveSensitizeButtons,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveSelWorkDirectory,event
daveDeSensitizeButtons,event
dave_defs=*!dave_defaults
old_directory=dave_defs.workDir
directory = DIALOG_PICKFILE(title = 'Select working directory',/directory,path=old_directory)
if (directory eq '' or directory eq ' ') then begin
  daveSensitizeButtons,event
  return
endif
dave_defs.workDir=directory
pdd=!dave_defaults
ptr_free,pdd
pdd=ptr_new(dave_defs)
save,filename=!defaults_file,pdd
defsysv,'!dave_defaults',pdd
cd,current=curDir
if (old_directory ne directory) then $
   x=dialog_message(["The raw data directory is "+(*!dave_defaults).datDir,"",$
     "The working directory is "+(*!dave_defaults).workDir],$
     /information)
daveSensitizeButtons,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveDisplayDirectories,event
daveDeSensitizeButtons,event
;cd,current=curDir
x=dialog_message(["The raw data directory is "+(*!dave_defaults).datDir,"",$
   "The working directory is "+(*!dave_defaults).workDir],$
        /information)
;  "The current directory is "+curDir],/information)
daveSensitizeButtons,event
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveSELpdfreader,event

dave_defs=*!dave_defaults
PDFReader=dave_defs.PDFReader
;print,"Current pdfreader is ",PDFReader

; check and then exit if reader's selected reader is okay
readerNotOkay = 'Yes'
if (strtrim(PDFReader,2) ne '') then begin
    message_text = ['Your PDF reader is currently set to:',PDFReader, $
                    'Are you sure you want to change this setting?']
    readerNotOkay = dialog_message(message_text,/question,/default_no, $
                                   title='PDF Reader Setting')
    readerBaseDir = strmid(PDFReader,0,strpos(PDFReader,!delimiter,/reverse_search))
endif
if (readerNotOkay eq 'No') then return ; nothing to do

; let user select select a reader
daveDeSensitizeButtons,event
if n_elements(event.top) gt 0 then begin
    acroread = dialog_pickfile(dialog_parent = event.top,/read, $
                               title="Please select your PDF reader", $
                               path=readerBaseDir, $
                               file = PDFReader)
endif else begin
    acroread = dialog_pickfile(/read, title="Please select your PDF reader", $
                               path=readerBaseDir, $
                               file = PDFReader)
endelse

if (acroread eq '' or acroread eq ' ') then begin
    daveSensitizeButtons,event
    return
endif
dave_defs.PDFReader=acroread
pdd=!dave_defaults
ptr_free,pdd
pdd=ptr_new(dave_defs)
save,filename=!defaults_file,pdd
defsysv,'!dave_defaults',pdd
print,"New pdfreader is ",(*!dave_defaults).PDFReader
daveSensitizeButtons,event
return
end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fdaveSwapDebugFlag, event

if (!debug) then $
  print,'!debug Old value: ',!debug

!debug = (!debug eq 0)? 1 : 0   ; switch !debug b/n 0 and 1

case !debug of                  ; set appropriate label
    0: widget_control, event.id, set_value='Switch on debug flag'
    1: widget_control, event.id, set_value='Switch off debug flag'
endcase

if (!debug) then $
  print,'!debug New value: ',!debug

end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro DCSreductionHelp,event
widget_control,event.top,get_uvalue = pState
;pdf_file = file_which('DCSreductionHelp.pdf',/include_current_dir)
;void = launch_help(pdf_file,tlb = event.top)
xdisplayfile,file_which('DCSreductionHelp.txt',/include_current_dir)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro hfbs_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('hfbsreduction.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro fcs_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('fcs_manual.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro menuitems_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('menuitems.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro pan_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('pandoc.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro rains_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('rains_models.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro mslice_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('dcs_mslice.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro ascii_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('ascii_help.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro gaussian98_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('gaussian1.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro rotord_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('diatomiccalc.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro rotorm_Help,event
widget_control,event.top,get_uvalue = pState
pdf_file = file_which('methylcalc.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro ToolsHelp,event
widget_control,event.top,get_uvalue = pState
;pdf_file = file_which('ToolsHelp.pdf',/include_current_dir)
;void = launch_help(pdf_file,tlb = event.top)
xdisplayfile,file_which('ToolsHelp.txt',/include_current_dir)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro DCSToolsHelp,event
widget_control,event.top,get_uvalue = pState
;pdf_file = file_which('DCSToolsHelp.pdf',/include_current_dir)
;void = launch_help(pdf_file,tlb = event.top)
xdisplayfile,file_which('DCSToolsHelp.txt',/include_current_dir)
return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro dave
; Widget definition module

;device,decomposed = 0
colorset
davesysvars

;
; If in the development environment, and running Windows,
; store the current directory.  Then make "C:\" the current directory.
if (not lmgr(/runtime) and !version.os_family eq "Windows") then begin
   cd,current=thisDir
   defsysv,'!thisDir',thisDir
   cd,"C:\"
endif

;
;
; No matter what, !dave_defaults is defined in the next few lines of code.
if (file_test(!defaults_file)) then begin
   restore,!defaults_file
   dave_defs=*pdd
   void = dave_defs_checkout(dave_defs)
   ptr_free, pdd
endif else begin
   cd,current = thisDir
   dave_defs = {datDir:thisDir,workDir:thisDir,PDFReader:'',web_browser:''}
endelse
; if no web browser is currently set, try locating one automatically
;if (strlen(strtrim(dave_defs.web_browser)) eq 0) then $
;  dave_defs.web_browser = locate_web_browser()
pdd=ptr_new(dave_defs)
save,filename=!defaults_file,pdd
defsysv,'!dave_defaults',pdd

; Determine the color depth of the computer
device,get_visual_depth = thisDepth
if thisDepth eq 8 then begin

   filename = file_which('DAVE_title.png',/include_current_dir)
   image = read_png(filename,r,g,b)
   s = size(image)
   sx = s[1] & sy = s[2]
endif else begin
   filename = file_which('DAVE_title.jpg',/include_current_dir)
   read_jpeg,filename,image
   s = size(image)
   sx = s[2] & sy = s[3]
endelse
aspect = 1.0*sy/sx     ; find the aspect ratio of the image...
; ...and set the display window's dimensions based on this
; aspect ratio.
winxsize = 600 & winysize = fix(aspect*winxsize)


if (lmgr(/runtime)) then tlb_title = 'DAVE: Data Analysis and Visualization Environment' $
  else tlb_title = 'DAVE: Data Analysis and Visualization Environment - running under IDLDE'
tlb = widget_base(/row,tlb_frame_attr = 0,mbar = bar, title = tlb_title)
win = widget_draw(tlb,xsize = winxsize,ysize = winysize)

filemenu = widget_button(bar,value = 'File',/menu)
;void = widget_button(filemenu,value = 'Define current directory',$
;                     xsize = butsize,event_pro = 'fdaveSelCurrentDirectory')
   void = widget_button(filemenu,value = 'Select raw data directory',$
                     xsize = butsize,event_pro = 'fdaveSelDataDirectory')
   void = widget_button(filemenu,value = 'Select working directory',$
                     xsize = butsize,event_pro = 'fdaveSelWorkDirectory')
   void = widget_button(filemenu,value = 'Display directories',$
                     xsize = butsize,event_pro = 'fdaveDisplayDirectories')
   void = widget_button(filemenu,value = 'Select pdf reader',$
                     xsize = butsize,event_pro = 'fdaveSELpdfreader')
; debug flag widget should not appear in embedded version
   if (not lmgr(/runtime)) then $
   void = widget_button(filemenu,value='Switch on debug flag',event_pro='fdaveSwapDebugFlag')
   void = widget_button(filemenu,value = 'Exit',event_pro = 'fdaveQuit',$
                     xsize = butsize)

redMenu = widget_button(bar,value = 'Data Reduction',/menu)
   dcsred = widget_button(redMenu,value = 'DCS',/menu)
     void = widget_button(dcsRed,value = 'Reduce DCS raw data',$
         event_pro = 'DCSReduceRawData')
     void = widget_button(dcsRed,value = 'DCS Mslice', $
      event_pro = 'dcs_mslice')
   fcsred = widget_button(redMenu,value = 'FCS',/menu)
     void = widget_button(fcsRed,value = 'Reduce FCS raw data',$
         event_pro = 'launchfcsreduction')
     void = widget_button(fcsRed,value = 'Help on FCS reduction',$
           event_pro = 'fcs_help')
   hfbsRed = widget_button(redMenu,value = 'HFBS',/menu)
;   void = widget_button(hfbsRed,value = 'Reduce .HFBS data',$
;      event_pro = 'hfbs_RunReduce')
     void = widget_button(hfbsRed,value = 'Reduce .HFBS data',$
      event_pro = 'launch_hfbsred')
     void = widget_button(hfbsRed,value = 'Reduce .HSCN data',$
      event_pro = 'hfbs_reduce_hscn')
     void = widget_button(hfbsRed,value = 'Convert DAVE to CON',$
      event_pro = 'hfbs_runCon')
     void = widget_button(hfbsRed,value = 'Help on HFBS reduction',$
      event_pro = 'hfbs_help')

;nsered = widget_button(redMenu,value = 'NSE',/menu);,event_pro = 'fdaveRedNSE')

   tasred = widget_button(redMenu,value = 'TAS',/menu);,event_pro = 'fdaveRedTAS')
;  void = widget_button(tasRed,value = 'Reduce PSD data',$
;            event_pro = 'fdaveTAS', uvalue='PSD')
     void = widget_button(tasRed,value = 'TASXP',$
         event_pro = 'fdaveTAS', uvalue='XP')
     void = widget_button(tasRed,value = 'ICP',$
         event_pro = 'launchSpecObj')

   fansRed = widget_button(redMenu,value = 'FANS',/menu)
     void = widget_button(fansRed,value='Reduce FANS (*.bt4) data',event_pro='launchfansdatreduc')

   asciiMenu = widget_button(redMenu,value = 'ASCII data',/menu)
;     threeColData = widget_button(asciiMenu,value = 'Read in x,y,yerr',$
;                       event_pro = 'fdaveRead3ColAscii')
   void = widget_button(asciiMenu,value = 'ASCII data->DAVE',event_pro = 'launch_ascii')
visMenu = widget_button(bar, value = 'Visualization', /menu)
   twoDRen = widget_button(visMenu, value = 'Trifenestra (Three Windows)' $
     , event_pro = 'fdaveTAS', uvalue='PSD')
   void = widget_button(visMenu,value = 'Simple image slicer',event_pro = 'daveLaunchIS')
   ;;void = widget_button(visMenu,value = 'Multiple dataset slicer',event_pro = 'launchdave_mdicer')
        void = widget_button(visMenu,value='Data Browser',event_pro='launch_dave_db')
   void = widget_button(visMenu,value = 'DAVE PEEK',event_pro = 'launch_dave_peek')
anMenu = widget_button(bar,value = 'Data Analysis',/menu)
   rainsButton = widget_button(anMenu,value = 'RAINS (Refinement Analysis of Inelastic Neutron Spectra)', $
     event_pro = 'launch_rains')
   panButton = widget_button(anMenu,value = 'PAN (Peak Analysis)',event_pro = 'launch_opan')

toolsMenu = widget_button(bar,value = 'Tools',/menu)
   genTools = widget_button(toolsMenu,value = 'General Tools',/menu)
     genDataTools = widget_button(genTools,value = 'Data Tools',/menu)
      void = widget_button(genDataTools,value = 'Examine data directories',$
         event_pro = 'quicklook4',uvalue='')
      void = widget_button(genDataTools,value = 'Create a DAVE data summary file',$
         event_pro = 'dave_summarize_ascii')
      void = widget_button(genDataTools,value = 'Examine a DAVE datafile',$
         event_pro = 'dave_examineDAVEfiles')
      void = widget_button(genDataTools,value = 'View a DAVE datafile treatment',$
         event_pro = 'dave_view_treatment')
      void = widget_button(genDataTools,value = 'Save DAVE data in ascii format',$
         event_pro = 'dave_save_ascii')
      void = widget_button(genDataTools,value = 'Rebin DAVE data file(s)',$
         event_pro = 'dave_rebindave')
      void = widget_button(genDataTools,value = 'A look at the current DAVE structure',$
         event_pro = 'fdaveTAS', uvalue = 'EXAMINE')
         void = widget_button(genDataTools,value='Spy on Specifics',$
     event_pro='launchSpySpecObj')   ; TMR Aug 1, 2003
     genMiscTools = widget_button(genTools,value = 'Miscellaneous',/menu)
      void = widget_button(genMiscTools,value = 'Self-shielding correction application',$
         event_pro = 'fdaveLaunchASC')
      void = widget_button(genMiscTools,value = 'Neutron calculator',$
         event_pro = 'fdaveLaunchNeutCalc')
      void = widget_button(genMiscTools,value = 'Points Digitizer (POD)',$
         event_pro = 'fdaveLaunchPOD')
      rotor = widget_button(genMiscTools,value = 'Hindered rotor calculators',/menu)
         void = widget_button(rotor,value = 'Diatomic rigid rotor',$
           event_pro = 'dave_rotor')
         void = widget_button(rotor,value = 'Methyl rotor',$
            event_pro = 'dave_mrotor')

   dcsTools = widget_button(toolsMenu,value = 'DCS Tools',/menu)
    dcsPlanTools = widget_button(dcsTools,value = 'Planning and execution',/menu)
      void = widget_button(dcsPlanTools,value = 'Intensity and resolution',$
         event_pro = 'DCSToolsPerformance')
      void = widget_button(dcsPlanTools,value = 'Experiment planner',$
         event_pro = 'DCSToolsPlanner')
      void = widget_button(dcsPlanTools,value = 'Calculate sample heights',$
          event_pro = 'DCSToolsHeights')
      void = widget_button(dcsPlanTools,value = 'Chopper phase calculator',$
         event_pro = 'DCSToolsPhases')
      void = widget_button(dcsPlanTools,value = '"Revenge" calculator',$
         event_pro = 'DCSToolsRevenge')
      void = widget_button(dcsPlanTools,value = 'Detector information',$
         event_pro = 'DCSToolsDetectors')
;      void = widget_button(dcsPlanTools,value = 'Rules of thumb',$
;         event_pro = 'DCSToolsThumbrules')
     dcsDataTools = widget_button(dcsTools,value = 'Data Tools',/menu)
      void = widget_button(dcsDataTools,value = 'Examine DCS data directories',$
         event_pro = 'quicklook4',uvalue='dcs')
      void = widget_button(dcsDataTools,value = 'Create a DCS raw data summary file',$
         event_pro = 'DCSSummarize_ascii')
      void = widget_button(dcsDataTools,value = 'Examine a DCS raw data file',$
         event_pro = 'dave_examinedcsfiles')
      void = widget_button(dcsDataTools,value = 'Save DCS raw data in ascii format',$
         event_pro = 'DCSSave_ascii')
      void = widget_button(dcsDataTools,value = 'Save DCS raw data in DAVE format',$
         event_pro = 'DCSSaveRawData_DAVE')
      void = widget_button(dcsDataTools,value = 'Convert sqw_i files to DAVE format',$
         event_pro = 'DCSConvertSqwiFile_DAVE')
            void = widget_button(dcsDataTools,value = 'Plot single crystal alignment files',$
         event_pro = 'dcs_cryst_align',/separator)
     dcsPlotTools = widget_button(dcsTools,value = 'DCS Multiplot utility',$
      event_pro = 'launchdcs_multiplot')
    dcsMiscTools = widget_button(dcsTools,value = 'Miscellaneous',/menu)
      void = widget_button(dcsMiscTools,value = 'Plot DCS run information',$
         event_pro = 'DCS_runsinfo')
      void = widget_button(dcsMiscTools,value = 'Perform raw data sanity checks',$
         event_pro = 'DCSToolsSanitycheck')
       void = widget_button(dcsMiscTools,value = 'Piecewise constant energy width time channels',$
         event_pro = 'DCSToolsTchannels_energy')
      void = widget_button(dcsMiscTools,value = 'Piecewise constant time width time channels',$
         event_pro = 'DCSToolsTchannels_time')

   hfbsTools = widget_button(toolsMenu,value = 'HFBS Tools',/menu)
     void = widget_button(hfbsTools,value = 'Databrowser',event_pro = 'davelaunchhfbsdb')
     fwsAnalysis = widget_button(hfbsTools,value = 'FWS Analysis',event_pro = 'fdaveLaunchFWS')

;  nseTools = widget_button(toolsMenu,value = 'Spin Echo Tools',/menu)

   tasTools = widget_button(toolsMenu,value = 'TAS Tools',/menu)
     void = widget_button(tasTools,value = 'Spurion calculator',event_pro = 'launchSpur')
;   void = widget_button(tasTools,value = 'Inelastic spurion calculator',event_pro = 'launchSpur2')

   fansTools = widget_button(toolsMenu,value = 'FANS Tools',/menu)
     void = widget_button(fansTools,value = 'Gaussian98 Calculation',event_pro = 'launchgaussian98')
     void = widget_button(fansTools,value = 'FANS Monochromator',event_pro = 'launchFansmonofit')
     void = widget_button(fansTools,value = 'FANS Data Browser',event_pro = 'launchFansBrowser')

;  funTools = widget_button(toolsMenu,value = 'Just for fun...',/menu)
;   void = widget_button(funTools,value = 'Data-blaster',$
;         event_pro = 'fdaveLaunchDataBlaster')

helpMenu = widget_button(bar,value = 'Help',/menu)
   void = widget_button(helpMenu,value='Menu descriptions',event_pro='menuitems_help')
   uman = widget_button(helpMenu,value='User manuals',/menu)
   void = widget_button(uman,value='ASCII reader',event_pro='ascii_help')
   void = widget_button(uman,value='Diatomic rigid rotor',event_pro='rotord_help')
   void = widget_button(uman,value='FCS data reduction',event_pro='fcs_help')
   void = widget_button(uman,value='Gaussian98',event_pro='gaussian98_help')
   void = widget_button(uman,value='HFBS data reduction',event_pro='hfbs_help')
   void = widget_button(uman,value='Methyl rotor',event_pro='rotorm_help')
   void = widget_button(uman,value='Mslice',event_pro='mslice_help')
   void = widget_button(uman,value='PAN',event_pro='pan_help')
   void = widget_button(uman,value='RAINS',event_pro='rains_help')
   
   void = widget_button(helpMenu,value = 'About DAVE',event_pro = 'fdaveAboutDave')

;  void = widget_button(miscMenu,value = 'Useful rules of thumb',$
;         event_pro = 'dave_thumbrules')

; Added this bit of code to allow users to enter their own menu items.  The code
; in the next three lines should never be modified nor should any one ever check
; a file called dave_users.pro into the CVS repository!
if file_which('dave_users.pro') ne '' then begin
  result = dave_users(bar)
endif
;
;helpMenu = widget_button(bar,value = 'Help',/menu)
;   void = widget_button(helpMenu,value = 'Help for DCS Data Reduction',$
;     event_pro = 'DCSReductionHelp')
;   void = widget_button(helpMenu,value = 'Help for General Tools',$
;     event_pro = 'ToolsHelp')
;   void = widget_button(helpMenu,value = 'Help for DCS Tools',$
;     event_pro = 'DCSToolsHelp')

; Center it all on the screen
centertlb,tlb

widget_control,tlb,/realize
widget_control,win,get_value = winVis
window,/free,/pixmap,xsize = winxsize,ysize = winysize
winPix = !d.window

;wset,winPix
if thisDepth eq 8 then begin
   device,decomposed = 0
   tvlct,r,g,b   ; load the proper color tables as found in
   ; read_png above.
   dispImage = congrid(image,winxsize,winysize)
endif else begin
   device,decomposed = 1
   dispimage = image
endelse

wset,winPix
tvimage,dispImage
wset,winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,winPix]
wdelete,winPix
;
device,/cursor_original
commonStr = {instrument:'',$
             histPtr:ptr_new(/allocate_heap),$
             xlabel:'',$
             ylabel:'',$
             xtype:'',$
             ytype:'',$
             xunits: '',$
             yunits: '',$
             histLabel:'',$
             histUnits:'',$
             treatmentPtr:ptr_new(/allocate_heap),$
             commonStrPtr:ptr_new()}

dataStr = {commonStr:commonStr,$
           specificPtr:ptr_new(/allocate_heap)}

dataStrPtr = ptr_new(dataStr,/no_copy)

panContainer = obj_new('IDL_CONTAINER')
panInfo = {panContainer:panContainer}

; DAVE developers can put whatever they like into
; this extra structure
extra = {panInfo:panInfo}
extraPtr = ptr_new(extra,/no_copy)

daveStr =    {davePtrStr, $     ; RTA - make davePtr structure a named structure
              dataStrPtr:dataStrPtr, $
              descriPtr:ptr_new()} ; remove /allocate_heap flag

davePtr = ptr_new(daveStr,/no_copy)
state = {davePtr:davePtr,extraPtr:extraPtr}

pState = ptr_new(state,/no_copy)
widget_control,tlb,set_uvalue = pState,/no_copy

xmanager,'dave',tlb,cleanup = 'daveCleanup',/no_block

return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
