$Id: quicklook4.pro,v 1.7 2003/11/24 17:49:43 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro quicklook4_cleanup,tlb
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,tlb,get_uvalue=pState
ptr_free,pState
end


;************************************************************************************************
pro quicklook4_quit,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,/destroy
end


;************************************************************************************************
pro quicklook4_makewidget,path,instrument,infilename,nfiles,nlines,nlabels,fileinfo,$
	labels,files,butt,$
;	choice,schoice,$
	tlb,group_leader=group_leader
;************************************************************************************************
;
compile_opt strictarr
;
;
; Navigate to starting directory, either ...summaryfiles or ...summaryfiles/dcs (or hfbs...)
cwd=sourceroot()
if (stregex(path,/boolean,'^[A-Z a-z]*$')) then path=cwd+"summaryfiles"+!delimiter+path
infilename=dialog_pickfile(path=path,filter="*filesummary*",get_path=path)
if (infilename eq "") then return
restore,infilename
;
; Number of items.
nlabels=n_elements(labels)
;
; Maximum number of lines in information display box.
; This is 1 more than the maximum number of displayable items.
nlines=nlabels+1
;
files=shortform_files
nfiles=n_elements(files)
butt=lonarr(nfiles)
;choice=lonarr(nchoice)
;schoice=lonarr(nchoice)
;
; Start to generate the widget.
if (group_leader eq 0l) then modal=0 else modal=1
tlb=widget_base(/row,title='Summary of '+instrument+' directory '+strmid(infilename,strpos(infilename,'200'),6)+$
	"  ("+strcompress(string(nfiles),/remove_all)+" files)",modal=modal,/tlb_frame_attr,group_leader=group_leader)
;
;	filemenu=widget_button(bar,value="File",/menu)
;		select=widget_button(filemenu,value="Select a new summary file")
;		clearitems=widget_button(filemenu,value="Clear all items")
;		checkitems=widget_button(filemenu,value="Check all items")
;	  done=widget_button(filemenu,value = 'Quit',event_pro='quicklook4_quit')
;	searchmenu=widget_button(bar,value="Search",/menu)
;		search=widget_button(searchmenu,value="Perform search")
;		clearsearch=widget_button(searchmenu,value="Resensitize all file names")
;
;	firstcolumn=widget_base(tlb,/col,/frame)
;		srchitem=widget_combobox(firstcolumn,value=["Search item",labels])
;		void=widget_label(firstcolumn,value="Search string")
;		srchtext=widget_text(firstcolumn,/editable)
;		srchstring=widget_combobox(firstcolumn,value=["Search string",' '],/editable)
;		nbase=widget_base(firstcolumn,/row)
;			void=widget_text(nbase,value="Files/column =",xsize=14)
;			numdef=widget_text(nbase,value='',xsize=3,/editable)
;		frame=widget_base(firstcolumn,/col,/frame)
;			if (nlines lt nchoice+1) then void=widget_label(frame,value="(Max."+strcompress(string(nlines-1))+" items)")
;			leftright=widget_base(frame,/row)
;				leftbase=widget_base(leftright,/col)
;					void=widget_label(leftbase,value="Display",/align_left)
;					choices=widget_base(leftbase,/col,/nonexclusive)
;						for m=0,nchoice-1 do begin
;							choice[m]=widget_button(choices,value=labels[m])
;						endfor
;				rightbase=widget_base(leftright,/col)
;					void=widget_label(rightbase,value="Search",/align_left)
;					schoices=widget_base(rightbase,/col,/exclusive)
;						for m=0,nchoice-1 do begin
;							schoice[m]=widget_button(schoices,value="")
;						endfor
;
	column=widget_base(tlb,/col,/frame)
		infobase=widget_base(column,/row)
			firstbase=widget_base(infobase,/col)
				select=widget_button(firstbase,value="Open new summary file",/frame)
			  srchbase=widget_base(firstbase,/col,/frame)
					void=widget_label(srchbase,value='1st search item and string')
					srchitem=widget_combobox(srchbase,value=labels)
					srchtext=widget_text(srchbase,/editable,/all_events)
					void=widget_label(srchbase,value='2nd search item and string')
					srchitem2=widget_combobox(srchbase,value=labels)
					srchtext2=widget_text(srchbase,/editable,/all_events)
					srchmode=widget_button(srchbase,value="Toggle search mode")
					search=widget_button(srchbase,value="Search AND")
					clearsearch=widget_button(srchbase,value="Reset file names")
			  done=widget_button(firstbase,value = 'Quit',/frame,event_pro='quicklook4_quit')
;				nbase=widget_base(srchbase,/row)
;					void=widget_text(nbase,value="Files/column =",xsize=14)
;					numdef=widget_text(nbase,value='',xsize=3,/editable)
			labeling=widget_text(infobase,xsize=max(strlen(labels)>strlen("File name")),$
				ysize=(1+nlabels)<nlines)
			info=widget_text(infobase,xsize=200,ysize=(1+nlabels)<nlines)
		filebase=widget_base(column,/row,/frame,/scroll)
;
; Generate a temporary base and some labels in order to determine the number of pixels in
; the y direction, per label. Having got the answer, destroy the temporary base and proceed.
; Don't bother if the total number of files is very small.
			xysize=get_screen_size()
			geom3=widget_info(infobase,/geometry)
			if (nfiles lt 12) then begin
				number=nfiles
			endif else begin
				tempbase=widget_base(filebase,/col)
				for k=0,11 do begin
					butt[k]=widget_label(tempbase,value=files[k],/tracking_events)
					if (k eq 1) then geom1a=widget_info(tempbase,/geometry)
					if (k eq 11) then begin
						geom1b=widget_info(tempbase,/geometry)
						dysize=0.1*(geom1b.ysize-geom1a.ysize)
					endif
				endfor
				number=fix((xysize[1]*0.8-geom3.ysize)/dysize)
				widget_control,tempbase,/destroy
			endelse
;			widget_control,numdef,set_value=strcompress(number)
;
; Generate the list of files.
			ncols=fix(nfiles/number)+1
			base=lonarr(ncols)
			for j=0,ncols-1 do begin
				base[j]=widget_base(filebase,/col)
				ks=j*number
				ke=((j+1)*number-1) < (nfiles-1)
				for k=ks,ke do begin
					butt[k]=widget_label(base[j],value=files[k],/tracking_events)
				endfor
			endfor
;
; Do some geometry calculations and set the width of items in the first column.
;geom1=widget_info(nbase,/geometry)
geom2=widget_info(srchitem,/geometry)
geom3=widget_info(srchtext,/geometry)
;maxxsize=1.2*(geom1.xsize>geom2.xsize>geom3.xsize)
maxxsize=1.2*(geom2.xsize>geom3.xsize)
;widget_control,nbase,xsize=maxxsize
widget_control,srchitem,xsize=maxxsize
widget_control,srchtext,scr_xsize=maxxsize
widget_control,srchitem2,xsize=maxxsize
widget_control,srchtext2,scr_xsize=maxxsize
;
; More geometry calculations (what a pain!).
geom1=widget_info(filebase,/geometry)
geom2=widget_info(infobase,/geometry)
xysize=get_screen_size()
widget_control,filebase,scr_xsize=((xysize[0]*0.9) < geom1.scr_xsize)
widget_control,filebase,scr_ysize=((xysize[1]*0.8-geom2.scr_ysize) < geom1.scr_ysize)+xysize[1]*0.025
widget_control,infobase,scr_xsize=((xysize[0]*0.9) < geom1.scr_xsize)
geom1=widget_info(infobase,/geometry)
geom2=widget_info(firstbase,/geometry)
geom3=widget_info(labeling,/geometry)
widget_control,info,scr_xsize=geom1.scr_xsize-geom2.scr_xsize-geom3.scr_xsize-12
centertlb,tlb
geom=widget_info(tlb,/geometry)
widget_control,tlb,yoffset=0.25*geom.yoffset
;
chosen=bytarr(nlabels)
chosen[0:nlines-2]=1
;
;for m=0,nchoice-1 do begin
;	widget_control,choice[m],set_button=chosen[m]
;endfor
widget_control,tlb,/realize
;
state={$
	group_leader:group_leader,$
	path:path,$
	select:select,$
	done:done,$
;	clearitems:clearitems,$
;	checkitems:checkitems,$
	labeling:labeling,$
	info:info,$
	nlabels:nlabels,$
;	choice:choice,$
;	schoice:schoice,$
	chosen:chosen,$
	labels:labels,$
	fileinfo:fileinfo,$
	files:files,$
	nfiles:nfiles,$
	butt:butt,$
	nlines:nlines,$
;	numdef:numdef,$
	column:column,$
	infobase:infobase,$
	filebase:filebase,$
	base:base,$
	srchtext:srchtext,$
	srchitem:srchitem,$
	searchstring:"",$
	searchitemnumber:0,$
	srchtext2:srchtext2,$
	srchitem2:srchitem2,$
	searchstring2:"",$
	searchitemnumber2:0,$
	srchmode:srchmode,$
	search:search,$
	clearsearch:clearsearch,$
	searchand:1}
;
pstate=ptr_new(state)
widget_control,tlb,set_uvalue=pstate
xmanager,"quicklook4",tlb,event_handler="quicklook4_handler",cleanup="quicklook4_cleanup"
;
end


;************************************************************************************************
pro quicklook4_handler,event
;************************************************************************************************
;
compile_opt strictarr
;
;
widget_control,event.top,get_uvalue=pState
;
; Handle the "Open new summary file" button.
if (event.id eq (*pstate).select) then begin
	path=(*pState).path
	group_leader=(*pState).group_leader
	quicklook4_quit,event
	quicklook4_makewidget,path,instrument,infilename,nfiles,nlines,nlabels,fileinfo,$
		labels,files,butt,$
	;	choice,schoice,$
		tlb,group_leader=group_leader
	return
endif
;
;if (event.id eq (*pstate).clearitems) then begin
;	nchoice=n_elements((*pState).choice)
;	for m=0,nchoice-1 do widget_control,(*pState).choice[m],set_button=0
;	(*pState).chosen=0
;endif
;;
;if (event.id eq (*pstate).checkitems) then begin
;	nchoice=n_elements((*pState).choice)
;	for m=0,nchoice-1 do widget_control,(*pState).choice[m],set_button=1
;	(*pState).chosen=1
;endif
;
; Handle the droplists that define search items.
if (event.id eq (*pState).srchitem) then begin
	(*pState).searchitemnumber=event.index
endif
;
if (event.id eq (*pState).srchitem2) then begin
	(*pState).searchitemnumber2=event.index
endif
;
; Handle the text widgets where the search strings are inserted.
; Hitting carriage return implies that a search is to be performed.
dosearch=0
if (event.id eq (*pState).srchtext) then begin
	widget_control,(*pState).srchtext,get_value=temp
	(*pState).searchstring='*'+temp+'*'
		if (event.type eq 0) then if (event.ch eq 10b) then dosearch=1
endif
;
if (event.id eq (*pState).srchtext2) then begin
	widget_control,(*pState).srchtext2,get_value=temp
	(*pState).searchstring2='*'+temp+'*'
		if (event.type eq 0) then if (event.ch eq 10b) then dosearch=1
endif
;
; Toggle between the two search modes.
if (event.id eq (*pState).srchmode) then begin
	(*pState).searchand=1-(*pState).searchand
	if ((*pState).searchand) then label="Search AND" else label="Search OR"
	widget_control,(*pState).search,set_value=label
endif
;
; Do the search and sensitize the file names that satisfy the search.
if (dosearch or event.id eq (*pstate).search) then begin
; Handle the AND search mode
	if ((*pState).searchand) then begin
		if ((*pState).searchstring ne '') then begin
			res=strmatch((*pState).fileinfo.((*pState).searchitemnumber),(*pState).searchstring,/fold_case)
		endif else res=bytarr((*pState).nfiles)+1
		if ((*pState).searchstring2 ne '') then begin
			res2=strmatch((*pState).fileinfo.((*pState).searchitemnumber2),(*pState).searchstring2,/fold_case)
		endif else res2=bytarr((*pState).nfiles)+1
		indices=where(res eq 0 or res2 eq 0)
	endif else begin
; Handle the OR search mode.
		if ((*pState).searchstring ne '') then begin
			res=strmatch((*pState).fileinfo.((*pState).searchitemnumber),(*pState).searchstring,/fold_case)
		endif else res=bytarr((*pState).nfiles)
		if ((*pState).searchstring2 ne '') then begin
			res2=strmatch((*pState).fileinfo.((*pState).searchitemnumber2),(*pState).searchstring2,/fold_case)
		endif else res2=bytarr((*pState).nfiles)
		indices=where(res eq 0 and res2 eq 0)
	endelse
; Set the new file label sensitivities.
	if (indices[0] ge 0) then offbutt=(*pState).butt[indices]
	widget_control,(*pState).filebase,map=0
	for k=0,(*pState).nfiles-1 do widget_control,(*pState).butt[k],/sensitive
	for k=0,n_elements(offbutt)-1 do widget_control,offbutt[k],sensitive=0
	widget_control,(*pState).filebase,map=1
endif
;
; Handle the "Clear search" button.
if (event.id eq (*pstate).clearsearch) then begin
	for k=0,(*pState).nfiles-1 do widget_control,(*pState).butt[k],/sensitive
endif
;
nlabels=(*pState).nlabels
;for m=0,nchoice-1 do begin
;	if (event.id eq (*pState).choice[m]) then begin
;		if (event.select eq 0) then (*pState).chosen[m]=0
;		if (event.select eq 1) then begin
;			if (total((*pState).chosen) lt (*pState).nlines-1) then begin
;				(*pState).chosen[m]=1
;			endif else begin
;				widget_control,(*pState).choice[m],set_button=0
;			endelse
;		endif
;	endif
;endfor
;;
;for m=0,nchoice-1 do begin
;	if (event.id eq (*pState).schoice[m]) then begin
;		if (event.select eq 1) then (*pState).searchitemnumber=m
;	endif
;endfor
;
; Display item labels.
info=' File name'
for m=0,nlabels-1 do begin
	if ((*pState).chosen[m]) then info=[info,' '+strcompress((*pState).labels[m])]
endfor
widget_control,(*pState).labeling,set_value=info
;
; Display item information for the file label where the cursor is placed.
if (tag_names(event,/structure_name) eq 'WIDGET_TRACKING') then begin
	if (event.enter eq 0) then begin
		widget_control,(*pState).info,set_value=''
	endif else begin
		for k=0,(*pState).nfiles-1 do begin
			if (event.id eq (*pstate).butt[k]) then begin
				info=' '+(*pState).files[k]
				for m=0,nlabels-1 do begin
					if ((*pState).chosen[m]) then info=[info,strcompress(string((*pState).fileinfo.(m)[k]))]
				endfor
				widget_control,(*pState).info,set_value=info
			endif
		endfor
	endelse
endif
;
;if (event.id eq (*pstate).numdef) then begin
;	widget_control,(*pstate).numdef,get_value=content
;	substr=stregex(content[0],/extract,'[1-9][0-9]*')
;	if (substr ne '') then begin
;		number=fix(substr)
;		widget_control,(*pState).filebase,/destroy
;		widget_control,event.top,map=0
;		tlb=widget_base(title="Please wait ...")
;		mess=widget_label(tlb,/align_center,value="Please wait while the display is updated.",font="TIMESROMAN*20*bold*italic")
;		centertlb,tlb
;		widget_control,tlb,/realize
;		(*pState).filebase=widget_base((*pState).column,/row,/frame,/scroll)
;		nfiles=(*pState).nfiles
;		ncols=fix(nfiles/number)+1
;		base=lonarr(ncols)
;		files=(*pState).files
;		butt=lonarr(nfiles)
;		for j=0,ncols-1 do begin
;			base[j]=widget_base((*pState).filebase,/col)
;			ks=j*number
;			ke=((j+1)*number-1) < (nfiles-1)
;			for k=ks,ke do begin
;				butt[k]=widget_label(base[j],value=files[k],/tracking_events)
;			endfor
;		endfor
;		(*pState).butt=butt
;		geom1=widget_info((*pState).filebase,/geometry)
;		geom2=widget_info((*pState).firstcolumn,/geometry)
;		geom3=widget_info((*pState).infobase,/geometry)
;		xysize=get_screen_size()
;		widget_control,(*pState).filebase,scr_xsize=((xysize[0]*0.8-geom2.scr_xsize) < geom1.scr_xsize)
;		widget_control,(*pState).filebase,scr_ysize=((xysize[1]*0.8-geom3.scr_ysize) < geom1.scr_ysize)+xysize[1]*0.025
;		centertlb,event.top
;		geom=widget_info(event.top,/geometry)
;		widget_control,event.top,yoffset=0.5*geom.yoffset
;		widget_control,(*pState).filebase,/realize
;		widget_control,tlb,/destroy
;		widget_control,event.top,map=1
;	endif
;endif
;
widget_control,event.top,set_uvalue=pState
;
end



;************************************************************************************************
pro quicklook4,event
;************************************************************************************************
;
compile_opt strictarr
;
;
if (n_elements(event) eq 0) then begin
	group_leader=0l
	path=''
endif else begin
	group_leader=event.top
	widget_control,event.id,get_uvalue=path
endelse
;
quicklook4_makewidget,path,group_leader=group_leader
;
end