;$Id: trifenestra_write_spe.pro,v 1.1 2002/04/23 14:47:01 jmspark Exp $
;
pro trifenestra_write_spe,file,x,y,z,dz,tit=tit,xtit=xtit,ytit=ytit,ztit=ztit $
	, Ei = Ei
	; INPUT
	;	file = file name
	;	x = horizontal axis data (1D vector)
	;	y = vertical axis data (1D vector)
	;	z = intensity (2D matrix)
	;	dz = error (2D matrix)
	;	Ei = string containing the initial energy, e.g., 2.3 (A)
	;
	; INPUT (optional)
	;	xtit = X axis title
	;	ytit = Y axis title
	;	ztit = intensity data title

if n_elements(Ei) eq 0 then Ei = 0d
if n_elements(tit) eq 0 then tit='I (Q,hw) | ' + string(Ei) + ' | (meV)'
if n_elements(xtit) eq 0 then xtit='Q (A-1)'
if n_elements(ytit) eq 0 then ytit='hw (meV)'
if n_elements(ztit) eq 0 then ztit='I (Q,hw)'

nx	=	n_elements(x)
ny	=	n_elements(y)
openw,lun,file,/get_lun
printf,lun,tit
printf,lun,nx,ny
printf,lun,xtit
printf,lun,x
printf,lun,ytit
printf,lun,y
for i=0,nx-1 do begin
	printf,lun,ztit
	printf,lun, reform( z(i,*) ), format='(4(e15.5))'
	printf,lun,'  Error'
	printf,lun, reform( dz(i,*) ), format='(4(e15.5))'
endfor
free_lun,lun

return
end

