;+
; NAME:
;       DAVE_tagContainer_example
;
; PURPOSE:
;
;	To test the class DAVE_tagContainer.
;	IDL> DAVE_tagContainer_example, #		(1 - 6)
;.........................................................................
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
;-
;=============================================================================
;*
pro DAVE_tagContainer_example, $
	whichexample		; Integer between 1-6. 0 means all
;/

  if (n_elements(whichexample) eq 0) then whichExample = 0

     tree = obj_new('DAVE_tagContainer'	)		;;, $
;;;     	 intendedTags = ['DAVE_tagContainer', 'tree', 'example0'])

     branch1 = obj_new('DAVE_tagContainer')
     branch1 -> add, $
        tags=['qtyObj', 'leaf1', 'example1'], $	; [class, name, codeSource]
     	contents=obj_new('qtyObj', name='leafleaf1', qty=1 )
     oleaf = obj_new('qtyObj', name='leafleaf2', qty=[2, 4] )
;     oleaf -> show
     branch1 -> add, $
        tags=['qtyObj', 'leaf2', 'example1'], $
     	contents=oleaf
;;     	contents=obj_new('qtyObj', name='leafleaf2', qty=[2, 4] )
     branch1 -> add, $
        tags=['qtyObj', 'leaf3', 'example1'], $
     	contents=obj_new('qtyObj', name='leafleaf3', $
		qty=[3, 9, 27], err=[0.3, 0.2, 0.1] )
     branch1 -> add, $
        tags=['qtyObj', 'leaf4', 'example1'], $
     	contents=obj_new('qtyObj', name='leafleaf4', $
		qty=[0.3, 0.6, 0.9] )
     tree -> Add, $
        tags=['branchObj', 'branch1', 'example1'], $
     	contents=branch1
  	 
     branch2 = obj_new('DAVE_tagContainer')
     branch2 -> add, $
        tags=['qtyObj', 'finger1', 'example1'], $
     	contents=obj_new('qtyObj', name='digit1', qty='one' )
     branch2 -> add, $
        tags=['qtyObj', 'finger2', 'example1'], $
     	contents=obj_new('qtyObj', name='digit2', qty=['two', 'too'] )
     branch2 -> add, $
        tags=['qtyObj', 'finger3', 'example1'], $
     	contents=obj_new('qtyObj', name='digit3', qty=['three', '3', 'trois'] )
     tree -> Add, $
        tags=['branchObj', 'branch2', 'example1'], $
     	contents=branch2

     tree -> Add, $
        tags=['branchObj', 'branch3', 'example1'], $
     	contents=obj_new('qtyObj', name='Stubby', qty=[[1,2], [3,4], [5,6]], $
		units='nanoseconds' )
  	 
  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 1)) then begin

    print, ' test method SHOW, mostly'

    print, "tree -> help_obj"
    tree -> help_obj
    print
    
    print, "tree -> print_obj"
    tree -> print_obj
    print
    
    print, 'tree -> show'
    tree -> show
    print
  
    print, 'tree -> show, /recursive'
    tree -> show, /recursive
    print

    print, "limb1 = tree -> get(pos=1)"
    limb1 = tree -> get(pos=1)
    print, "limb1 -> print_obj		; should be branch1"
    limb1 -> print_obj			; should be branch1
    print
    print, "limb1 -> show		; should be branch1"
    limb1 -> show		; should be branch1
    print
    
;    obj_destroy, tree   
;    check_heap  
 
  endif		;; (whichexample eq 1)
  
  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 2)) then begin
    print, ' test method REMOVE, mostly'
    print, "tree -> help_obj"
    tree -> help_obj
    print
        
    reallyDestroy = 1

    test_pos = 0
    test_tag = 1
    test_child = 0
    test_all = 0

;    goto, destroy_all

  ;....................................
  if (test_pos) then begin
    print, 'tree -> remove, position = 99, destroy=', reallyDestroy
    tree -> remove, position = 99, destroy=reallyDestroy
    print, 'tree -> show, /recursive'
    tree -> show, /recursive
    print
;;    goto, label_check
 
    print, 'tree -> remove, position = 1, destroy=', reallyDestroy
    tree -> remove, position = 1, destroy=reallyDestroy
    print, 'tree -> show, /recursive'
    tree -> show, /recursive
    print
  endif		; test_pos
 
  ;....................................
  if (test_tag) then begin
    print, "tree -> remove, ", $ 
    	"position = ['branchObj', 'branch99', 'example1'], ", $
    	"destroy=", reallyDestroy
    tree -> remove, position = ['branchObj', 'branch99', 'example1'], $
    	destroy=reallyDestroy
    print

    print, "tree -> remove, position = ['branchObj', 'branch3', 'example1'],", $
    	" destroy=", reallyDestroy
    tree -> remove, position = ['branchObj', 'branch3', 'example1'], $
    	destroy=reallyDestroy
    print, 'tree -> show, /recursive'
    tree -> show, /recursive
    print
  endif		; test_tag

  ;....................................
  if (test_child) then begin	; this is a child object that is being removed
    print, 'tree -> show, /recursive'
    tree -> show, /recursive
    print

;Debug    print, 'branch1 -> show, /recursive'
;Debug    branch1 -> show, /recursive
;Debug    print
;Debug    help, branch1
;Debug    print, 'obj_valid(branch1) = ', obj_valid(branch1)
;Debug    print
	
    print, "tree -> remove, branch99, ", $
    	"destroy=", reallyDestroy
;Debug    print, 'obj_valid(branch99) = ', obj_valid(branch99)
;Debug    print, 'obj_valid(branch1) = ', obj_valid(branch1)
    tree -> remove, branch99, $
    	destroy=reallyDestroy
;Debug    print, 'obj_valid(branch1) = ', obj_valid(branch1)
    print

    print, "tree -> remove, branch1, ", $
    	"destroy=", reallyDestroy
;Debug    print, 'obj_valid(branch1) = ', obj_valid(branch1)
    tree -> remove, branch1, $
    	destroy=reallyDestroy
;Debug    print, 'obj_valid(branch1) = ', obj_valid(branch1)
    print

    print, 'tree -> show, /recursive'
    tree -> show, /recursive
    print
  endif		; test_child

 
  if (test_all) then begin
;;;destroy_all:			;; works
    print, "tree -> remove, /all, destroy=", reallyDestroy
    tree -> remove, /all, destroy=reallyDestroy
    print, 'tree -> show, /recursive'
    tree -> show, /recursive
  endif
  
;label_check:

;    print, 'obj_destroy, tree			;; to get rid of the root.'
;    obj_destroy, tree   
;    print
;    check_heap  
 
    
  endif		;; (whichexample eq 2)

  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 3)) then begin
    print, ' test method MOVE, mostly'
    print, "tree -> help_obj"
    tree -> help_obj
    tree -> show, /recursive
    print

    test_pos = 0
    test_tag = 1

    if (test_pos) then begin
      print, "tree -> move, 2, 0"
      tree -> move, 2, 0
      print, 'tree -> show, /recursive'
      tree -> show, /recursive
      print
    endif        

    if (test_tag) then begin
      print, "tree -> move, ['branchObj', 'branch3', 'example1'],",  $
		    "['branchObj', 'branch0', 'example1']"
      tree -> move, ['branchObj', 'branch3', 'example1'], $
		    ['branchObj', 'branch0', 'example1']
      print

      print, "tree -> move, ['branchObj', 'branch333', 'example1'],",  $
		    "['branchObj', 'branch1', 'example1']"
      tree -> move, ['branchObj', 'branch333', 'example1'], $
		    ['branchObj', 'branch1', 'example1']
      print

      print, "tree -> move, ['branchObj', 'branch3', 'example1'],",  $
		    "['branchObj', 'branch1', 'example1']"
      tree -> move, ['branchObj', 'branch3', 'example1'], $
		    ['branchObj', 'branch1', 'example1']
      print, 'tree -> show, /recursive'
      tree -> show, /recursive
      print
    endif        

;    print, 'obj_destroy, tree			;; to get rid of the root.'
;    obj_destroy, tree   
;    print
;    check_heap  
 
  endif		; ;; (whichexample eq 3)  


  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 4)) then begin
    print, ' test method TAGISUNIQUE, mostly'
    print, "tree -> help_obj"
;    tree -> help_obj
    tree -> show, /recursive
    print

    print, " tree -> Add, tags=['branchObj', 'branch3', 'example1'], ..."
    tempObj=obj_new('qtyObj', name='Cconehead', qty=[1,2,3,4, 5,6], $
		units='nano-nano' )
  	 
     tree -> Add, $
        tags=['branchObj', 'branch3', 'example1'], $
     	contents=tempObj
;;	contents=obj_new('qtyObj', name='Cconehead', qty=[1,2,3,4, 5,6], $
;;		units='nano-nano' )
  	 
    tree -> show, /recursive
    print
    
    obj_destroy, tempObj

  endif		; ;; (whichexample eq 4)  
 
  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 5)) then begin
    print, ' test method CALLMETHOD, mostly'

    print, '--------------------------'
    dummyOK = tree -> callMethod( 'show', /isPro, /recursive)
    print, dummyOK, "=tree -> callMethod('show', /isPro, recursive=1)"
    print


    print, '--------------------------'
    dummyOK = tree -> callMethod('move', 0, 2, /isPro)
    print, dummyOK, "= tree -> callMethod('move', 0, 2)"
    tree -> show, /recursive
    print

    print, '--------------------------'
    ncount = tree -> callMethod('count')
    print, ncount, "=tree -> callMethod('count')"
    print

    print, '--------------------------'
    arrayA = [0,1,2,3]
    arrayB = [[1,2], [3,4]]
    res = tree -> callFunction('eqArrays', arrayA, arrayB)
    print, res, "=tree -> callFunction('eqArrays', [0,1,2,3], [[1,2], [3,4]])"
    print

    print, '--------------------------'
    arrayC = [[0,1], [2,3]]
    res = tree -> callFunction('eqArrays', arrayA, arrayC)
    print, res, "=tree -> callFunction('eqArrays', [0,1,2,3], [[0,1], [2,3]])"
    print

    print, '--------------------------'
     ; Procedure printArgPresent not intended for general structures.
;    anonRec = {a:'AA', b:'BB', num:12.5}
;    tree -> callProcedure, 'printArgPresent', anonRec
;    print, "tree -> callProcedure, 'printArgPresent', {a:'AA', b:'BB', num:12.5}"
;    print
    
    argPresent = {a:0, b:1, num:1}	; Anonymous strucutre of true/false
    tree -> callProcedure, 'printArgPresent', /showValues, argPresent
    print, "tree -> callProcedure, 'printArgPresent', /showValues, ", $
    	"{a:0, b:1, num:1}"
    print
    tree -> callProcedure, 'printArgPresent', argPresent
    print, "tree -> callProcedure, 'printArgPresent', ", $
    	"{a:0, b:1, num:1}	; Intended Use"
    print


    print, '--------------------------'
    arrayD = [9,8,7]
    res = tree -> callFunction('eqArrays', arrayA, arrayD, /verbose)
    print, res, "=tree -> callFunction('eqArrays', [0,1,2,3], [9,8,7], /verbose)"
    print

    print, '--------------------------'
    arrayE = [0,1,2]
    res = tree -> callFunction('eqArrays', arrayA, arrayE)
    print, res, "=tree -> callFunction('eqArrays', [0,1,2,3], [0,1,2])"
    print
    
    print, '--------------------------'

  endif		; ;; (whichexample eq 5)  
 
  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 6)) then begin
    print, ' test focusObj, mostly'
    
     datatree     = obj_new('DAVE_tagContainer'	)		;;, $
;;;     	 intendedTags = ['DAVE_tagContainer', 'tree', 'example0'])

     dbranch1 = obj_new('DAVE_tagContainer')
     dbranch1 -> add, $
		; tags = [class, name, codeSource]
        tags = ['qtyObj', 'filename', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='filename', qty='cehex011.bc7' )

     dbranch1 -> add, $
        tags = ['qtyObj', 'mainTitle', 'DAVE_TagContainer_example6'], $
    	contents=obj_new('qtyObj', $
	  name= 'mainTitle', $
	  qty= ['cehex011.bc7', 'May  3 2002 00:01', 'cehex CeB6 single crystal.'], $
	  legend= ['filename', 'date', 'comments'])
	
     dbranch1 -> add, $
        tags = ['qtyObj', 'date', 'DAVE_TagContainer_example6'], $
    	contents=obj_new('qtyObj', name='date', qty= 'May  3 2002 00:01')
     dbranch1 -> add, $
        tags = ['qtyObj', 'scanStyle', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='scanStyle', qty='Q' )
     dbranch1 -> add, $
        tags = ['qtyObj', 'collimation', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='collimation', $
		qty=[60, 60, 20, 99] )
     dbranch1 -> add, $
        tags = ['qtyObj', 'latDim', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Lattice Dimensions', $
	  qty=[4.141, 4.141, 4.141],units='AA', legend = ['a', 'b', 'c'] )
     dbranch1 -> add, $
        tags = ['qtyObj', 'latAngles', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Lattice Angles', $
	  qty=[90.000, 90.000, 90.000], units='degrees', $
	   legend = ['alpha', 'beta', 'gamma'] )
     dbranch1 -> add, $
        tags = ['qtyObj', 'Q_center', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Q_center', $
	;; err is the step size
	  qty=[0.250, 0.250, 0.500], err=[ 0.0000, 0.0000, 0.0000 ], $
	  units='degrees', legend = ['h', 'k', 'l'] )
     dbranch1 -> add, $
        tags = ['qtyObj', 'T_start', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Temperature Set Point', $
	;; err is the step size
	  qty= 1.65000 , err=0.300, units='Kelvin')
     dbranch1 -> add, $
        tags = ['qtyObj', 'specific_cut', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Energy', $
	  qty= 1.75000 , units='meV', legend = 'y')
     datatree -> Add, $
        tags=['DVheader', 'dbranch1', 'example6'], $
     	contents=dbranch1
  	 
     dbranch2 = obj_new('DAVE_tagContainer')
     dbranch2 -> add, $
        tags = ['qtyObj', 'T-act', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Temperature, measured', $
	  qty=[ 1.536, 1.5477, 1.574, 1.5991, 1.6165, 1.6551], $
	  legend = ['t1', 't2', 't3', 't4', 't5', 't6'], $
	  units = 'Kelvin')
     dbranch2 -> add, $
        tags = ['qtyObj', 'min', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Length of measurement', $
	  qty=[ 5.12, 5.08, 5.10, 5.12, 5.13, 5.17], units = 'Minutes')
     cqty = [1465, 1427, 1419, 1392, 1416, 1412]
     cerr = sqrt(cqty)
     dbranch2 -> add, $
        tags = ['qtyObj', 'Counts', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Neutron Counts', $
	  qty=cqty, err=cerr, units = 'Events')
     datatree -> Add, $
        tags = ['DVdata', 'dbranch2', 'DAVE_TagContainer_example6'], $
     	contents = dbranch2

;Old    treeFocus = obj_new('focusObj', datatree, dbranch1, dbranch2, $ ; root,header,data

    treeFocus = obj_new('focusObj', $
        container = datatree, $
	headerObj = dbranch1, $
	dataObj = dbranch2, $ 
        mainTitleTags = ['qtyObj', 'mainTitle', 'DAVE_TagContainer_example6'], $
;	descripTags = ['qtyObj', 'Q_center', 'DAVE_TagContainer_example6'], $ 
;	descripLegend = 'h', $
	descripTags = ['qtyObj', 'T_start', 'DAVE_TagContainer_example6'], $ 
	descripLegend = '', $
	cutTags = ['qtyObj', 'specific_cut', 'DAVE_TagContainer_example6'], $
   	xTags = ['qtyObj', 'T-act', 'DAVE_TagContainer_example6'], $
   	zTags = ['qtyObj', 'Counts', 'DAVE_TagContainer_example6'])

    treeFocus -> show	
    print, 'treeFocus -> show ------------------------------------------'
    print
        	
    treeFocus -> plot
    print, 'treeFocus -> plot ------------------------------------------'
;    treeFocus -> plotxz
;    print, 'treeFocus -> plotxz ------------------------------------------'
    print	    	

    treeFocus2 = obj_new('focusObj', $
        container = datatree, $
	headerObj = dbranch1, $
	dataObj = dbranch2, $ 
   	xTags = ['qtyObj', 'T-act', 'DAVE_TagContainer_example6'], $
   	zTags = ['qtyObj', 'Counts', 'DAVE_TagContainer_example6'])
    treeFocus2 -> show	
    print, 'treeFocus2 -> show ------------------------------------------'
    print

    print, "About to call report_obj... --------------"
    print
    
    hpNum = 1
    ;-------------- write info to a file ----------------------    	
    report_obj, datatree, 'info_dave_tagcontainer.txt', heapNum=hpNum 
    print, "report_obj, datatree, 'info_dave_tagcontainer.txt', heapNum=hpNum --------------"
    print

    ;-------------- write info to a file ----------------------    
    aTagObj = dbranch2 -> getTag(position =  $
    		['qtyObj','Counts','DAVE_TagContainer_example6'])	
    report_obj, aTagObj, 'info_tagobj.txt', heapNum=hpNum 
    print, "report_obj, aTagObj, 'info_tagobj.txt', heapNum=hpNum --------------"
    print

    ;-------------- write info to a file ----------------------    	
    report_obj, treeFocus, 'info_focusObj.txt', heapNum=hpNum 
    print, "report_obj, treeFocus, 'info_focusObj.txt', heapNum=hpNum  --------------"
    print
       	 
    ;-------------- write info to a file ----------------------    	
    littleObj = obj_new('qtyObj', name='Lattice Dimensions', $
	  qty=[4.141, 4.141, 4.141],units='AA', legend = ['a', 'b', 'c'] )
    report_obj, littleObj, 'info_qtyObj.txt', heapNum=hpNum 
    print, "report_obj, littleObj, 'info_qtyObj.txt', heapNum=hpNum  --------------"
    print
    obj_destroy, littleObj

    ;-------------- write info to a file ----------------------    	
    mqty = [[0, 1, 12, 15], [50, 69, 99, 100], [102345, 123545, 98123, 12312321]]
    mnerr = sqrt(mqty)
    merr = mnerr > 1
    littleObj = obj_new('qtyObj', name='2D matrix', $
	  qty=mqty, err=merr, nerr = mnerr, units='Events' )
    report_obj, littleObj, 'info_qtyObj_matrix.txt', heapNum=hpNum 
    print, "report_obj, littleObj, 'info_qtyObj_matrix.txt', heapNum=hpNum  --------------"
    print
    obj_destroy, littleObj

    ;-------- cleanup -------------------------------------- 
    obj_destroy, datatree
    obj_destroy, treeFocus 
    obj_destroy, treeFocus2 
  endif		; ;; (whichexample eq 6)  
  ;--------------------------------------------------------------
 
  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 7)) then begin
    print, ' test clone, mostly'
    
     datatree     = obj_new('DAVE_tagContainer'	)		;;, $
;;;     	 intendedTags = ['DAVE_tagContainer', 'tree', 'example0'])

     dbranch1 = obj_new('DAVE_tagContainer')
     dbranch1 -> add, $
		; tags = [class, name, codeSource]
        tags = ['qtyObj', 'filename', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='filename', qty='cehex011.bc7' )

     dbranch1 -> add, $
        tags = ['qtyObj', 'mainTitle', 'DAVE_TagContainer_example6'], $
    	contents=obj_new('qtyObj', $
	  name= 'mainTitle', $
	  qty= ['cehex011.bc7', 'May  3 2002 00:01', 'cehex CeB6 single crystal.'], $
	  legend= ['filename', 'date', 'comments'])
	
     dbranch1 -> add, $
        tags = ['qtyObj', 'date', 'DAVE_TagContainer_example6'], $
    	contents=obj_new('qtyObj', name='date', qty= 'May  3 2002 00:01')
     dbranch1 -> add, $
        tags = ['qtyObj', 'scanStyle', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='scanStyle', qty='Q' )
     dbranch1 -> add, $
        tags = ['qtyObj', 'collimation', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='collimation', $
		qty=[60, 60, 20, 99] )
     dbranch1 -> add, $
        tags = ['qtyObj', 'latDim', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Lattice Dimensions', $
	  qty=[4.141, 4.141, 4.141],units='AA', legend = ['a', 'b', 'c'] )
     dbranch1 -> add, $
        tags = ['qtyObj', 'latAngles', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Lattice Angles', $
	  qty=[90.000, 90.000, 90.000], units='degrees', $
	   legend = ['alpha', 'beta', 'gamma'] )
     dbranch1 -> add, $
        tags = ['qtyObj', 'Q_center', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Q_center', $
	;; err is the step size
	  qty=[0.250, 0.250, 0.500], err=[ 0.0000, 0.0000, 0.0000 ], $
	  units='degrees', legend = ['h', 'k', 'l'] )
     dbranch1 -> add, $
        tags = ['qtyObj', 'T_start', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Temperature Set Point', $
	;; err is the step size
	  qty= 1.65000 , err=0.300, units='Kelvin')
     dbranch1 -> add, $
        tags = ['qtyObj', 'specific_cut', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Energy', $
	  qty= 1.75000 , units='meV', legend = 'y')
     datatree -> Add, $
        tags=['DVheader', 'dbranch1', 'example6'], $
     	contents=dbranch1
  	 
     dbranch2 = obj_new('DAVE_tagContainer')
     dbranch2 -> add, $
        tags = ['qtyObj', 'T-act', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Temperature, measured', $
	  qty=[ 1.536, 1.5477, 1.574, 1.5991, 1.6165, 1.6551], $
	  legend = ['t1', 't2', 't3', 't4', 't5', 't6'], $
	  units = 'Kelvin')
     dbranch2 -> add, $
        tags = ['qtyObj', 'min', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Length of measurement', $
	  qty=[ 5.12, 5.08, 5.10, 5.12, 5.13, 5.17], units = 'Minutes')
     cqty = [1465, 1427, 1419, 1392, 1416, 1412]
     cerr = sqrt(cqty)
     dbranch2 -> add, $
        tags = ['qtyObj', 'Counts', 'DAVE_TagContainer_example6'], $
     	contents=obj_new('qtyObj', name='Neutron Counts', $
	  qty=cqty, err=cerr, units = 'Events')
     datatree -> Add, $
        tags = ['DVdata', 'dbranch2', 'DAVE_TagContainer_example6'], $
     	contents = dbranch2
	

;Old    treeFocus = obj_new('focusObj', datatree, dbranch1, dbranch2, $ ; root,header,data

;    treeFocus = obj_new('focusObj', $
;        container = datatree, $
;	headerObj = dbranch1, $
;	dataObj = dbranch2, $ 
;        mainTitleTags = ['qtyObj', 'mainTitle', 'DAVE_TagContainer_example6'], $
;;	descripTags = ['qtyObj', 'Q_center', 'DAVE_TagContainer_example6'], $ 
;;	descripLegend = 'h', $
;	descripTags = ['qtyObj', 'T_start', 'DAVE_TagContainer_example6'], $ 
;	descripLegend = '', $
;	cutTags = ['qtyObj', 'specific_cut', 'DAVE_TagContainer_example6'], $
;   	xTags = ['qtyObj', 'T-act', 'DAVE_TagContainer_example6'], $
;   	zTags = ['qtyObj', 'Counts', 'DAVE_TagContainer_example6'])

;    treeFocus -> show	
;    print, 'treeFocus -> show ------------------------------------------'
;    print
;        	
;    treeFocus -> plot
;    print, 'treeFocus -> plot ------------------------------------------'
;    print	    	


    print, "About to call report_obj... --------------"
    print
    
   hpNum = 1
     datatree -> show 
    print, "datatree -> show  --------------"
    print

    report_obj, datatree,  heapNum=hpNum 
    print, "report_obj, datatree,  heapNum=hpNum --------------"
    print

    clone = dataTree -> clone()
    report_obj, clone,  heapNum=hpNum 
    print, "report_obj, clone,  heapNum=hpNum --------------"
    print
    
;    hpNum = 1
;    ;-------------- write info to a file ----------------------    	
;    report_obj, datatree, 'info_dave_tagcontainer.txt', heapNum=hpNum 
;    print, "report_obj, datatree, 'info_dave_tagcontainer.txt', heapNum=hpNum --------------"
;    print

;    ;-------------- write info to a file ----------------------    	
;    report_obj, treeFocus, 'info_focusObj.txt', heapNum=hpNum 
;    print, "report_obj, treeFocus, 'info_focusObj.txt', heapNum=hpNum  --------------"
;    print
       	 
    ;-------- cleanup -------------------------------------- 
    obj_destroy, datatree
    obj_destroy, clone
  endif		; ;; (whichexample eq 7)  
  ;--------------------------------------------------------------
 
    print, 'obj_destroy, tree			;; to get rid of the root.'
    obj_destroy, tree   
    print

    check_heap  
 

end			;; DAVE_tagContainer_example

