; $Id: generic__help_obj_frag.pro,v 1.1 2003/07/23 14:15:13 tanya Exp $ 
;+
; NAME:
; 	generic__help_obj_frag.pro
;
; PURPOSE:
; 	Fragment of method code for all classes	 <class>::help_obj
; 	Insert in your class defintion.
;
;	pro YourClass::help_obj, $
;	  ; Note: The following keywords are only used by internal recrusion call.
;	  methodsOnly=methodsOnly,  helpProStr=strProArray, $
;		helpFuncStr=strFuncArray, class=thisClass
;
;	  @generic__help_obj_frag.pro
;	end
;	
; 	This avoids cut and paste proliferation of code, perhaps.
;
;	This code fragment requires YourClass::helpClass.
;
;	Note: In IDL, classes using inheritance basically construct
; one huge structure including all the data. The inherited methods
; have access to ALL of the data in the structure, not just the parts that
; are relevent to the inherited class. Therefore it is best to use these
; generic code fragements for methods ::print_obj and ::help_obj
; ONLY FOR THE TOP MOST CLASS which has inherited classes.
;
; I have found that it is preferable to make a container class 
; DAVE_tagContainer with basically two trees in parallel,
; one for the basic "data" using the class qtyObj and 
; another for I/O and GUI issues using the class tagObj.
; This is specifically to avoid creating a new class which inherits
; qtyObj and tagObj. 
;
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; CATEGORY:
;
;       Objects. DAVE application programming.
;
; SEE ALSO:
;	<LI><A HREF="#AAA_README">AAA_README</A>
;
; MODIFICATION HISTORY:
;	 Written by Tanya Riseman, Feb 4, 2003
;-
;###########################################################################
;
; LICENSE
;
; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.
;
;###########################################################################
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Frag pro generic_obj::help_obj, $
;Frag	; Note: The following keywords are only used by internal recrusion call.
;Frag	methodsOnly=methodsOnly,  helpProStr=strProArray,  $
;Frag	helpFuncStr=strFuncArray, class=thisClass, level=level
;Frag		lun=thisLun


;Unit Attributes Name
;-2   Write, Truncate, Tty, Reserved   <stderr>
;-1   Write, Truncate, Tty, Reserved   <stdout>
;0   Read, Tty, Reserved              <stdin>
  if (n_elements(thisLun) eq 0) then begin
      lun= -1
  endif else begin
      lun = thisLun
  endelse

;  if (n_elements(strArray) EQ 0) then begin
;    help, /routines, output = strArray
;  endif
 
  if (n_elements(strProArray) EQ 0) then begin
    help, /routines, /procedures, output = strProArray
  endif
 
  if (n_elements(strFuncArray) EQ 0) then begin
    help, /routines, /functions, output = strFuncArray
  endif
 
  if (n_elements(level) EQ 0) then begin
    level = 0
  endif
 
 if (not keyword_set(methodsOnly)) then begin
  theSuperClasses = obj_class(self, count=nclass, /superclass)
  OK = execute(string('junkRec = {', obj_class(self), '}'))
  theTagnames =   tag_names(junkRec)  
  ntags = n_tags(junkrec)
;;;  printf, lun, "... Could extend to have <TRIANGLE>. and <SHAPE>. instead of self."
  printf, lun, 'Class ', obj_class(self), $
  		' has ', strtrim(ntags, 2), ' tags of type: '
  for i = 0, (ntags-1) do begin
    infoTags = thetagNames[i] + ' ' + size(self.(i), /tname)
    if (n_elements(self.(i)) NE 1) then begin
      infotags = infotags  + '[' +  strtrim(n_elements(self.(i)), 2) + '] '
    endif
    if (size(self.(i), /tname) eq 'POINTER') then begin
      if (ptr_valid(self.(i))) then begin 
        infotags = infotags  + ' ' + size(*(self.(i)), /tname)
        if (n_elements(*(self.(i))) NE 1) then begin
          infotags = infotags  + '[' +  strtrim(n_elements(*(self.(i))), 2) + '] '
        endif
      endif else begin
        infotags = infotags + ' UNDEF'
      endelse
      
    endif
    printf, lun, 'self.', infoTags
  endfor
 endif
   
;  sLen = n_elements(strArray)
  sProLen = n_elements(strProArray)
  sFuncLen = n_elements(strFuncArray)

  if ((sProLen+sFuncLen) gt 0) then begin
;  if (sLen gt 0) then begin
    if (n_elements(thisClass) EQ 0) then begin	; do the object's class
       mySelf = obj_class(self)
       printf, lun, myself, ' using the methods: ', $
       		'(lowercase:arguments UPPERCASE:keywords)'
;       self->helpClass, class=mySelf, helpStr=strArray, level=level, lun=lun
       self->helpClass, class=mySelf,$
       	 helpProStr=strProArray, helpFuncStr=strFuncArray, level=level, lun=lun

    endif else begin	; do the Object's Superclass thisClass
;      self->helpClass, class=thisClass, helpStr=strArray, level=level, lun=lun
      self->helpClass, class=thisClass, $
      	helpProStr=strProArray, helpFuncStr=strFuncArray, $
       level=level, lun=lun
    endelse

    if (n_elements(thisClass) EQ 0) then begin ; recursion
      theSuperClasses = obj_class(self, count=nclass, /superclass)
    endif else begin
      classStr = string( $
     	'theSuperClasses = obj_class("', thisClass, $
		'", count=nclass, /superclass)')
      OK = execute(classStr)
      if ( not OK) then printf, lun, ' Failed execute'
    endelse
    cLen_array = n_elements(theSuperClasses)
    cLen = cLen_array[0] 
;    printf, lun, 'cLen_array = ', clen_array, ' clen = ', clen
;    help, clen
;    printf, lun, 'theSuperClasses =', theSuperClasses 
;    help, theSuperClasses
    More = 1
    if (clen eq 0) then More = 0
    if (clen eq 1) then begin
      if (theSuperclasses EQ '') then More = 0
    endif
    if (More) then begin
        level = level + 1
        for ic = 0, (clen-1) do begin	; Here's the recursion
	  call_method, 'help_obj', self,  $
		class=theSuperClasses[ic],  helpProStr=strProArray,$
		helpFuncStr=strFuncArray, $, 
;		class=theSuperClasses[ic],  helpStr=strArray, $, 
		/methodsOnly, $
		level=level, lun=lun
	  if (not OK) then printf, lun, 'Failed'
        endfor
    endif

  endif

;Frag end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;