; $Id: launch_davesave.pro,v 1.1 2003/08/07 16:13:53 tanya Exp $
;+
; NAME:
;       launch_davesave
;
; PURPOSE:
;
;	This is the launch manager for DAVE data save file OPEN/SAVE/REVIEW/CLOSE.
;
; AUTHOR:
;	Tanya Riseman, Ph.D. and Richard Azuah, Ph.D.
;       NIST Center for Neutron Research
;       100 Bureau Drive
;       Gaithersburg, MD 20899
;
; CATEGORY:
;
;       DAVE application button.
;
; SEE ALSO:
;	<LI><A HREF="#SPECOBJ__DEFINE_arguments">SPECOBJ__DEFINE_arguments</A>
;
; MODIFICATION HISTORY:
;	 Tanya Riseman and Richard Azuah. Aug 6, 2003.
;-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro launch_davesave, event

widget_control,event.top,get_uvalue = pState
widget_control,event.id,get_value = davesave_what

thisEvent = tag_names(event,/structure_name)

message, /info, string("Event = ", thisEvent)

case thisEvent of

'WIDGET_BUTTON':$
  begin
      daveDeSensitizeButtons,event
      call_procedure, davesave_what, $
      	(*pState).davePtr,notifyIds=[event.id,event.top], $
      	group_leader=event.top
  end

'DAVESAVE_EVENT': $
  ; One cleanup routine for davesave_open, davesave_save, 
  ; davesave_review and davesave_empty
  begin
  daveSensitizeButtons,event
  end

else:

endcase
return
end
