; $Id: launchspecobj.pro,v 1.5 2003/09/10 19:26:52 tanya Exp $
;+
; NAME:
;       launchspecobj
;
; PURPOSE:
;
;	This is the launch manager for DAVE program button which launches 
; the specObj reduction methods.
;
; AUTHOR:
;	Richard Azuah, Ph.D.
;       NIST Center for Neutron Research
;       100 Bureau Drive
;       Gaithersburg, MD 20899
;
; CATEGORY:
;
;       DAVE application button.
;
; SEE ALSO:
; 	<LI><A HREF="#REDUCESPECOBJ">REDUCESPECOBJ</A>
;	<LI><A HREF="#SPECOBJ__DEFINE_arguments">SPECOBJ__DEFINE_arguments</A>
;
; MODIFICATION HISTORY:
;	Richard Azuah and Tanya Riseman, July 23, 2003.
;	TMR. Sept 8, 2003. Call REDUCE_FRGD_BKGD_SPECOBJ instead of REDUCESPECOBJ
;	TMR. Sept 10, 2003. renamed REDUCE_FRGD_BKGD_SPECOBJ  REDUCESPECOBJ.
;-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Dave launcher for Tanya's ICP data reduction
pro launchSpecObj, event

widget_control,event.top,get_uvalue = pState

;print, ptr_valid(pState)
;help, pstate
;help, (*pState)
;print, " launcher pState=", (*pState)

thisEvent = tag_names(event,/structure_name)
case thisEvent of

'WIDGET_BUTTON':$
  begin
      daveDeSensitizeButtons,event
;      if (!debug) then begin
;        message, /info, "About to enter reduceSpecObj"
;        help, /heap
;        message, /info, "help, davePtr ="
;        help, (*pState).davePtr
;      endif
      reduceSpecObj,(*pState).davePtr,notifyIds=[event.id,event.top], $
      	group_leader=event.top
  end

'REDUCESPECOBJEVENT': $
  begin
;      if (!debug) then begin
;        message, /info, "About to enter return to Dave"
;        help, /heap
;      endif
;  message, /info, string("About to enter return to Dave, event=", event)
  daveSensitizeButtons,event
  end
else:
endcase
return
end
