;+
; NAME:
;       qtyObj_example
;
; PURPOSE:
;
;	To test the class qtyObj.
;	IDL> qtyobj_example, #		(1 - 13, 22)
;.........................................................................
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
;-
;*
pro qtyObj_example, $
	whichexample		; Integer (1 - 12, 22). 0 means all
;/
 if (n_elements(whichexample) eq 0) then whichExample = 0

 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 1)) then begin
  col0 = obj_new('qtyObj')		;empty
  OK = col0 -> set(name='col0', units='K')
  OK = col0 -> set($
	qty = [1.6d0, 2.6d0, 3.6d0, 4.6d0, 5.6d0, 6.6d0],  $
	legend = ['a', 'b', 'c', 'd', 'e', 'f'], $
	err = [0.11d0, 0.21d0, 0.31d0, 0.41d0, 0.51d0, 0.61d0])	; works
  if (not OK) then print, 'OK=', OK
  col0 -> show
  print
  thisDescripTitle = ''		; Pre-define so that arg_present will work.
  ok = col0 -> getOneValue(forPos = [3], $
 		oneqty = thisOneQty, oneerr = thisOneErr,$
		onelegend=thisOneLegend, $
		descripTitle = thisDescripTitle)
		; don't need irow. Fill with junk value.
  print, 'thisDescripTitle= "', thisDescripTitle, '"'
   print, "n_elements = ", n_elements(thisDescripTitle)
   print
   
   Print, "Problem:  these seem to be arrays not scalars."
   print, 'col0 get has: ', transpose(thisOneQty), $
	' +- ', transpose(thisOneErr), ' <', transpose(thisOneLegend),'>'
;   print, 'col0 get has: ', string(thisOneQty), $
;	' +- ', string(thisOneErr), ' <', string(thisOneLegend),'>'
  print

  ok = col0 -> setOneValue( forPos =[3], $
  	oneqty = 44.4, oneerr = 0.0004, onelegend='DDD')
  col0 -> show
  print

  OK = col0 -> remove(forPos=1)
  print, OK, " = OK = col0 -> remove(forPos=1). ; Should work"
  col0 -> show
  print

  OK = col0 -> remove(forLegend='c')
  print, OK, " = OK = col0 -> remove(forLegend='c'). ; Should work"
  col0 -> show
  print

  OK = col0 -> remove(forLegend='d')
  print, OK, " = OK = col0 -> remove(forLegend='d'). ; Should NOT work"
  col0 -> show
  print

  print, "col0 -> print_obj, /alsoPtrs"
  col0 -> print_obj, /alsoPtrs
  print
  

  OK = col0 -> removeAll()
  print, OK, " = OK = col0 -> removeAll()"
  col0 -> show
  print

  print, "col0 -> help_obj"
  col0 -> help_obj
  print
  
  print, "col0 -> print_obj"
  col0 -> print_obj
  print
  
  obj_destroy, col0
 endif
 
 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 2)) then begin
  print, "This leaves danging pointers"
  col4 = obj_new('qtyObj')		;empty
  OK = col4 -> set(name='col4', units='m')
  OK = col4 -> set($
	ptr_qty = ptr_new([[1.6, 2.6], [3.6, 4.6]]),  $
	ptr_err = ptr_new([[0.11, 0.21], [0.31, 0.41]]) )	; works
  if (not OK) then print, 'OK=', OK
  ipos = -1		; need to create variable ahead of time.
  col4 -> show

  obj_destroy, col4
 endif
 
 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 22)) then begin
  print, "This does not leave danging pointers"
  col4 = obj_new('qtyObj')		;empty
  OK = col4 -> set(name='col4', units='m')
  if (not OK) then print, 'set OK=', OK
  junk_ptr =  ptr_new([0.11d0, 0.21d0, 0.31d0, 0.41d0, 0.51d0, 0.61d0])
  OK = col4 -> set(ptr_qty = junk_ptr)	; works
  ptr_free, junk_ptr
  if (not OK) then print, 'set OK=', OK
  col4 -> show
  test_IS, col4
  obj_destroy, col4
 endif
 
 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 3)) then begin
  col1 = obj_new('qtyObj')		;empty
  OK = col1 -> set(name='col1',  $
	legend = [['1leg', '2leg'], ['3leg', '4leg'], ['5leg', '6leg']], $
	qty = [[1, 2], [3, 4], [5, 6]], $
	err = [[1, 1], [1, 1], [1, 1]])
  if (not OK) then print, 'OK=', OK
  print, "col1 -> show"
  col1 -> show
  OK = col1 -> get(everything=thisEVERYTHING, $
     ptr_qty=thisptr_qty, qty=thisqty, name=Thisname)
   print
   print, ' Echoing back from get:'
   print, 'name = ', thisname
   print, 'qty = ', thisqty
   print, 'ptr_qty = ', thisptr_qty 
   print, '*(ptr_qty) = ', *(thisptr_qty )
   print
   print, 'help, thisptr_qty'
   help, thisptr_qty
   print 
   print,  'thiseverything='		; A string array of info
   nel = n_elements(thisEverything)
   for i = 0, (nel-1) do begin
  	print, thisEverything[i]
   endfor
  print
  print, "Note: return value of second parameter in positionLegend ", $
  	"is an array in this case, not scalar."
    OK = col1 -> positionLegend('3leg', ipos)
    print, OK, " = col1 -> positionLegend('3leg', ", ipos, ")"
;;    print, "ipos = col4 -> positionLegend('Alpha') = ", ipos

  ptr_free,  thisptr_qty
  obj_destroy, col1
 endif
 
 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 4)) then begin
  print, "col0 has only qty, which is all the same value in the array."
  col0 = obj_new('qtyObj', $
	qty = [0.6d0, 0.6d0, 0.6d0, 0.6d0, 0.6d0, 0.6d0])	; works
  test_IS, col0

  print, "Create an empty qtyObj Col2with sizing and type (COMPLEX)  pre-defined"
  col2 = obj_new('qtyObj')		;empty
  OK = col2 -> set(name='col2', rank = 2, dim = [3,2], $
;;;;  n_rows=3, n_cols = 2,   $
	tname = 'COMPLEX')
  if (not OK) then print, 'OK=', OK
  col2 -> show
  print
  print, 'Now overriding col2 (size 3X2) with col0 (size 6). Does not work.'
  OK = col0 -> get(qty=tempQty) 
  OK = col2 -> set(qty=tempQty)
  ok  = col2->get(rank=rank2, dim=dim2)
  print, 'col2->get(rank=rank2, dim=dim2)=', rank2, dim2
  col2-> show
  print
  obj_destroy, col2
 endif
 
 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 5)) then begin
  print, "Example of a scalar qtyObj."
  col5 = obj_new('qtyObj', $
  	name='col5', units='cm', qty=33.3, err=0.03, $
	legend='kIcKy')
  col5 -> show
  test_IS, col5
  obj_destroy, col5
 endif

 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 6)) then begin
   print, "Can not have a legend without qty of the same length. Crashes"
   print, 'No reason why you should want to do this. See example 7.'
   col6 = obj_new('qtyObj', $
  	name='col6', units='strings', $	
	legend = [['a', 'A'], ['b', 'B'], ['c', 'C']])
  col6 -> show
  obj_destroy, col6
 endif

 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 7)) then begin
  print, 'String types are OK for qty.'
  col7 = obj_new('qtyObj', $
  	name='col7', units='more_strings', $
	qty = [['a', 'A'], ['b', 'B'], ['c', 'C']], $
	err = [['ea', 'EA'], ['eb', 'eB'], ['ec', 'eC']], $
	legend = [['1', '11'], ['2', '22'], ['3', '33']])
  test_IS, col7
  print
  col7 -> show
  print, ' Testing forPos'
  spec = [0,0]		; first element.
;  spec = [2-1,4-1]	; irow out of range
   spec = [2-1,3-1]	; Good. far corner
;Stupid  spec = [2,3]	; icol out of range
    OK = col7 -> get(qty=vQty, err=vErr, legend=vLegend, $
    		rank=rank, dim=dim, all=thisall)
    OK = col7 -> getOnevalue( oneqty=aQty, oneerr=aErr, onelegend=aLegend,  $
    		forPos = spec)
    if (not OK) then print, 'OK=', OK
    print,  'all=', thisall
    temp = size(vqty)
    print, 'Dimensions of qty are  =', temp[1], temp[2]
    print, 'rank=', rank
    print, 'dim=', dim
    print, 'vqty=', vqty, 'verr=', verr, 'vleg=', vLegend   
    print, 'Request single value at spec=', spec 
    print, 'specified oneqty=', aqty, '; ', 'oneerr=', aerr,'; ', 'oneleg=', aLegend   
    print

     
  obj_destroy, col7
 endif  

 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 8)) then begin
  print, 'Demonstrate asymmetric error bars'
  print, 'First: symmetric errors. '
  print, 'NOTE: QTY is type INT and ERR type FLOAT.'
  vqty = [100, 95, 50, 11, 120, 133, 89, 11]	; note: type INT
  verr = sqrt(float(vqty))			; type float
  col8 = obj_new('qtyObj', name='counts', units='Events', $
  	qty = vqty, err= verr)	; will set force the type of qty?
  col8 -> show
  print
  thisSOme = 'silly'
  ok = col8 -> get(everything=thisEverything, all=thisall, $
  	some=thisSome, axisTitle=thisAxisTitle)
  if (not OK) then print, 'OK=', OK
  print, 'thiseverything='
  print, thiseverything
  print
  print, 'thisall='
  print, thisall
  print
  print, 'thisaxistitle= "', thisAxisTitle, '"'
  print
;Broken  print, 'thissome='
;Broken  print, thissome
;Broken print
  ok =  col8 -> get( $
  	qty = vqty, err= verr)	; will set force the type of qty?
  vqty_new = sqrt(vqty)
  verr_new = sqrt(vqty + verr) - vqty_new
  vnerr_new = vqty_new - sqrt(vqty - verr)
  ok =  col8 -> set(  name='sqrt(counts)',$
  	qty = vqty_new, err= verr_new, nerr=vnerr_new)	; will set force the type of qty?
  print, ' Now replacing contents with the square root. Now asymmetric errors.'
  if (not OK) then print, 'OK=', OK
  print, 'col8 -> show'
  col8 -> show
  print
  ok = col8 -> get(everything=thisEverything, all=thisall, $
  	some=thisSome, axisTitle=thisAxisTitle, $
	qty = vqty_new2, err= verr_new2, nerr=vnerr_new2)
  if (not OK) then print, 'OK=', OK
  print, 'thiseverything='
  print, thiseverything
  print
  print, 'thisaxistitle= "', thisAxisTitle, '"'
  print
  test_IS, col8
  print
  obj_destroy, col8
 endif
 
 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 9)) then begin
  print, 'Test IS routines.'
  print, 'col9 contains a scalar, then a vector of constants.'
  print, 'col99 contains an object'
  col9 = obj_new('qtyObj', $
  	name='col9', units='units_scalar', $
	qty = 99)
  col9 -> show
  test_IS, col9
  print
  obj_destroy, col9
  col9 = obj_new('qtyObj', $
  	name='col9', units='units_constant', $
	legend = [ 1, 2, 3, 4, 5, 6, 7], $  ;what if this is not a string array?
	qty = [1, 1, 1, 1, 1, 1, 1])
  col9 -> show
  test_IS, col9
  print
  print, ' NOw put in varying errors.'
  OK = col9 -> set(err=[ 1, 2, 3, 4, 5, 6, 7])
  if (not OK) then print, 'OK=', OK
  col9 -> show
  test_IS, col9
  print

  col99 = obj_new('qtyObj', $
  	name='col99', units='Objective units', $
	qty = col9)
  OK = col9 -> get(tname = thisTname) 
  if (not OK) then print, 'OK=', OK
  print, 'col9 -> get(tname = thisTname). Tname = ', thistname 
  col99 -> show
  test_IS, col99
  print
  obj_destroy, col9
  obj_destroy, col99
 endif  

 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 10)) then begin
  print, 'Test Append method. Original object col10 is:'
  col10 = obj_new('qtyObj', $
  	name='col10', units='units_constant', $
	qty = [ 1, 2, 3, 4, 5, 6, 7], $
	err=sqrt(float([ 1, 2, 3, 4, 5, 6, 7])) )
  col10 -> show
  
  print, ' Now Append stuff. First using arrays'
  moreQty = [8, 9, 10]
;  moreErr = sqrt(float([8, 9, 10]))
;  print, "more=", moreQty, moreErr
;  OK = col10 -> Append(qty = moreQty, err=moreErr )
  OK = col10 -> Append(qty = [8, 9, 10], err=sqrt(float([8, 9, 10])) )
  if (not OK) then print, 'OK=', OK
  col10 -> show
  
  print, ' Now Append stuff. Next Appending another qtyObj'
  col101 = obj_new('qtyObj', $
  	name='col101', units='Objective units', $
	qty = [11, 12, 13], err=sqrt(float([11, 12, 13])) )
  OK = col10 -> Append(obj=col101 )
  if (not OK) then print, 'OK=', OK
  col10 -> show

  print, ' Now Append stuff of another type FLOAT not integer. IDL should convert.'
  OK = col10 -> Append(qty = [14.2, 14.8, 15.2], err=sqrt([14.2, 14.8, 15.2]) )
  if (not OK) then print, 'OK=', OK
  col10 -> show
  
  print, ' Now Append stuff. Append a single item'
  OK = col10 -> Append(qty = 16, err=sqrt(float(16)) )
  if (not OK) then print, 'OK=', OK
  col10 -> show
  
  print, ' Now Append stuff. Append mismatched array lengths. Should fail gracefully.'
  OK = col10 -> Append(qty = [17, 18, 19], err=sqrt(float(17)) )
  if (not OK) then print, 'OK=', OK
  col10 -> show
  
  print, ' Now Append stuff. Append mismatched fields. Should fail gracefully.'
  OK = col10 -> Append(qty = [17, 18, 19], $
  	err=sqrt([17, 18, 19]), nerr=sqrt([17, 18, 19]) )
  if (not OK) then print, 'OK=', OK
  col10 -> show
  
  print, ' Now Append stuff of another type STRING not integer. Should fail with zeros.'
  OK = col10 -> Append(qty = ['a', 'b', 'c'], err= ['ea', 'eb', 'ec'])
  if (not OK) then print, 'OK=', OK
  col10 -> show
  
  print, ' Now Append legend array when did not have any legend. Should fail.'
  OK = col10 -> Append(qty = [17, 18, 19], err= sqrt(float([17, 18, 19])), $
    legend = ['ea', 'eb', 'ec'])
  if (not OK) then print, 'OK=', OK
  col10 -> show
  
  print, ' Now remove some data using forPos = 3 keyword'
  OK = col10 -> remove(forPos = 3)
  if (not OK) then print, 'OK=', OK
  col10 -> show
  
  print, ' Now remove some data using forPos = [1, 0] keyword. ', $
  	' Does not make much sense.'
  OK = col10 -> remove(forPos = [1, 0])
  if (not OK) then print, 'OK=', OK
  col10 -> show

  obj_destroy, col10
  obj_destroy, col101
 endif  

 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 11)) then begin
    print, whichexample, 'Test postionIndex'
    col11 = obj_new('qtyObj', $
  	name='col11', units='units_constant', $
	qty = [ [1, 2, 3], [4, 5, 6]], $
	err=sqrt(float([ [1, 2, 3], [4, 5, 6]])), $
	legend=[['a', 'b', 'c'], ['AA', 'BB', 'CC']])
    ok = col11 -> get(legend=mylegend)
    print, mylegend        
    ipos = -1
    OK = col11 -> positionLegend('BB', ipos)
;    ipos = col11 -> positionLegend('BB', ipos)
    print, OK , " = col11 -> positionLegend('BB', ", ipos, ")"
    
    obj_destroy, col11
 endif

 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 12)) then begin
    print, whichexample, 'Test scalar qtyObj'
    col12 = obj_new('qtyObj', $
  	name='col12', units='units_constant', $
	qty = 123.4567, $
	err= sqrt(123.456), $
	nerr= sqrt(12.3456), $
	legend='Nah' )
    col12 -> show	
    print

    print, "Don't know why this fails"    
    ok = col12 -> remove(forLegend='nah')
    print, ok, "=ok = col12 -> remove(forLegend='nah')"
    col12-> show
    print

    print, "Don't know why this fails"    
    ok = col12 -> remove(forLegend='Nah')
    print, ok, "=ok = col12 -> remove(forLegend='Nah')"
    col12-> show
    print

    print, "Should work."
    ok = col12 -> Append(qty=[1,2,3], $
     	err = [1,2,3], $
	nerr=[0.1, 0.2, 0.3], $
    	legend=['alpha', 'beta', 'gamma'])
    print, ok, "=ok = col12 -> Append([qty=[1,2,3],err=[1,2,3], ", $
    	"nerr=[0.1, 0.2, 0.3], legend=['alpha', 'beta', 'gamma'])"
    col12-> show
    print


    print, "Should fail. No err or nerr."
    ok = col12 -> Append(qty=[1, 2, 3], $
    	legend=['alpha', 'beta', 'gamma'])
    print, ok, "=ok = col12 -> Append(qty=[1,2,3], ", $
    	"legend=['alpha', 'beta', 'gamma'])"
    col12-> show
    print

    print, "Should fail. Strings not numerical values."
    ok = col12 -> Append(qty=['one', 'two', 'three'], $
     	err = [1,2,3], $
	nerr=[0.1, 0.2, 0.3], $
    	legend=['alpha', 'beta', 'gamma'])
    print, ok, "=ok = col12 -> Append(qty=['one', 'two', 'three'], ", $
    	"legend=['alpha', 'beta', 'gamma'])"
    col12-> show
    print

    obj_destroy, col12
 endif

 ;--------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 13)) then begin
  col0 = obj_new('qtyObj', name='col0', units='K', $
  	qty = [1.6d0, 2.6d0, 3.6d0, 4.6d0, 5.6d0, 6.6d0],  $
	legend = ['a', 'b', 'c', 'd', 'e', 'f'], $
	err = [0.11d0, 0.21d0, 0.31d0, 0.41d0, 0.51d0, 0.61d0])	

  clone = col0-> clone()
  print, ' clone = col0-> clone() ----------------'
  print

  ok = col0 -> setOneValue( forPos =[3], $
  	oneqty = 44.4, oneerr = 0.0004, onelegend='DDD')
;  if (not OK) then print, 'OK=', OK
;  col0 -> show
;  print

  OK = col0 -> remove(forPos=1)
  print, OK, " = OK = col0 -> remove(forPos=1). ;---------- Should work"
;  col0 -> show
;  print

  OK = col0 -> remove(forLegend='c')
  print, OK, " = OK = col0 -> remove(forLegend='c'). ;------- Should work"
;  col0 -> show
;  print


  col0 -> show
  print, ' col0 -> show ----------------'
  print

  clone -> show
  print, ' clone -> show ----------------'
  print

  col0 -> print_obj, /alsoPtrs
  print, "col0 -> print_obj, /alsoPtrs ------------------"
  print
  
  clone -> print_obj, /alsoPtrs
  print, "clone -> print_obj, /alsoPtrs ---------------------------"
  print
  

;  OK = col0 -> removeAll()
;  print, OK, " = OK = col0 -> removeAll()"
;  col0 -> show
;  print
;
;  print, "col0 -> help_obj"
;  col0 -> help_obj
;  print
;  
;  print, "col0 -> print_obj"
;  col0 -> print_obj
;  print
  
  obj_destroy, col0
  obj_destroy, clone
 endif
 
 ;--------------------------------------------------------------
;  if (obj_valid(col0)) then obj_destroy, col0
  check_heap
;;  qtyObj_heap
  
end		;  qtyObj_example

;================================================================================
pro test_IS, thisObj

  print, 'thingy -> isScalar =', thisObj -> isScalar()
  print, 'thingy -> isConstant =', thisObj -> isConstant()
  print, 'thingy -> isNumeric =', thisObj -> isNumeric()
 
end

