; $Id: triasubs_lcd.pro,v 1.2 2003/09/12 15:24:51 tanya Exp $
;+
; NAME:
;       triasubs_lcd
;
; PURPOSE:
;
; Based on subroutine lcd(u,v,uirr,virr) in spurion file calclattice.f
;C  Find the lowest common denominator fac in the 3-vector uirr.
;
; 	Based on Fortran routines used by spurion program.
;	These routines are used by func_icp_header_init and func_icp_data_init.
;
;.........................................................................
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; SEE ALSO:
;	<LI><A HREF="#FUNC_ICP_DATA_INIT">FUNC_ICP_DATA_INIT</A>
;	<LI><A HREF="#FUNC_ICP_HEADER_INIT">FUNC_ICP_HEADER_INIT</A>
;	
; MODIFICATION HISTORY:
;
;       Written by Tanya Riseman, Dec 18, 2002.
;	Split func_icp_subs.pro into separate files. TMR. Aug 1, 2003
;-

;=======================================================================
pro triasubs_lcd, $ ;Find the lowest common denominator fac in the 3-vector uirr.
	uirr, fac
; Based on subroutine lcd(u,v,uirr,virr) in spurion file calclattice.f
;C  Find the lowest common denominator fac in the 3-vector uirr.

  debug = 0

   nprimes = 26		; more than we will ever need.
   primes_vec = primes(nprimes)
   
   check_again:
   if (norm(uirr) gt 0) then begin
   ; Alternative is stupid (e.g. all zeros)
     for i = 0, (nprimes -1) do begin
       comm = 1	; true. Common denominator is found using modulo operator
       for j = 0, 2 do begin
         comm = comm and ( (fix(uirr[j]) mod primes_vec[i]) EQ 0 )
       endfor
       if (comm) then begin
         for j = 0, 2 do begin
          uirr(j) = uirr[j] / primes_vec[i]
	 endfor
	 fac = fac * primes_vec[i]
	 goto, check_again	; might have multiples of the same prime factor
       endif
     endfor
   endif

;C include a quick check of negatives
   comm = 1	; true. Common denominator is found using modulo operator
   for j = 0, 2 do begin
      comm = comm and (abs(uirr[j]) eq -uirr[j])
   endfor
   if (comm) then begin
     for j = 0, 2 do begin
       uirr[j] = -uirr[j]
     endfor
   endif   

end		; triasubs_lcd

